/* Generated automatically by the program `genemit'
from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "memmodel.h"
#include "tm_p.h"
#include "flags.h"
#include "insn-config.h"
#include "expmed.h"
#include "dojump.h"
#include "explow.h"
#include "emit-rtl.h"
#include "stmt.h"
#include "expr.h"
#include "insn-codes.h"
#include "optabs.h"
#include "dfp.h"
#include "output.h"
#include "recog.h"
#include "df.h"
#include "resource.h"
#include "reload.h"
#include "diagnostic-core.h"
#include "regs.h"
#include "tm-constrs.h"
#include "ggc.h"
#include "target.h"

/* ../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md:1865 */
rtx
gen_reload_inpdi (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_CLOBBER (VOIDmode,
	operand2)));
}

/* ../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md:1865 */
rtx
gen_reload_inv2pdi (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_CLOBBER (VOIDmode,
	operand2)));
}

/* ../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md:1885 */
rtx
gen_reload_outpdi (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_CLOBBER (VOIDmode,
	operand2)));
}

/* ../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md:1885 */
rtx
gen_reload_outv2pdi (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_CLOBBER (VOIDmode,
	operand2)));
}

/* ../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md:1907 */
rtx
gen_jump (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (pc_rtx,
	gen_rtx_LABEL_REF (VOIDmode,
	operand0));
}

/* ../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md:1919 */
rtx
gen_indirect_jump (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (pc_rtx,
	operand0);
}

/* ../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md:1974 */
rtx
gen_loop_end (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_NE (VOIDmode,
	operand2,
	const1_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand1),
	pc_rtx)),
		gen_rtx_SET (operand0,
	gen_rtx_PLUS (VOIDmode,
	copy_rtx (operand2),
	constm1_rtx)),
		gen_rtx_UNSPEC (VOIDmode,
	gen_rtvec (1,
		const0_rtx),
	10),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode)),
		gen_hard_reg_clobber (BImode, 34)));
}

/* ../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md:2017 */
rtx
gen_lsetup_with_autoinit (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED,
	rtx operand4 ATTRIBUTE_UNUSED,
	rtx operand5 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (operand0,
	gen_rtx_LABEL_REF (VOIDmode,
	operand1)),
		gen_rtx_SET (operand2,
	gen_rtx_LABEL_REF (VOIDmode,
	operand3)),
		gen_rtx_SET (operand4,
	operand5)));
}

/* ../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md:2028 */
rtx
gen_lsetup_without_autoinit (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED,
	rtx operand4 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (operand0,
	gen_rtx_LABEL_REF (VOIDmode,
	operand1)),
		gen_rtx_SET (operand2,
	gen_rtx_LABEL_REF (VOIDmode,
	operand3)),
		gen_rtx_USE (VOIDmode,
	operand4)));
}

/* ../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md:2044 */
rtx
gen_load_funcdescsi (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_UNSPEC_VOLATILE (SImode,
	gen_rtvec (1,
		gen_rtx_MEM (SImode,
	operand1)),
	3));
}

/* ../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md:2297 */
rtx
gen_rep_movsi (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED,
	rtx operand4 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (8,
		gen_rtx_SET (operand0,
	gen_rtx_PLUS (SImode,
	gen_rtx_PLUS (SImode,
	operand3,
	gen_rtx_ASHIFT (SImode,
	operand2,
	const_int_rtx[MAX_SAVED_CONST_INT + (2)])),
	const_int_rtx[MAX_SAVED_CONST_INT + (4)])),
		gen_rtx_SET (operand1,
	gen_rtx_PLUS (SImode,
	gen_rtx_PLUS (SImode,
	operand4,
	gen_rtx_ASHIFT (SImode,
	copy_rtx (operand2),
	const_int_rtx[MAX_SAVED_CONST_INT + (2)])),
	const_int_rtx[MAX_SAVED_CONST_INT + (4)])),
		gen_rtx_SET (gen_rtx_MEM (BLKmode,
	copy_rtx (operand3)),
	gen_rtx_MEM (BLKmode,
	copy_rtx (operand4))),
		gen_rtx_USE (VOIDmode,
	copy_rtx (operand2)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (HImode)),
		gen_hard_reg_clobber (SImode, 45),
		gen_hard_reg_clobber (SImode, 47),
		gen_hard_reg_clobber (SImode, 49)));
}

/* ../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md:2320 */
rtx
gen_rep_movhi (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED,
	rtx operand4 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (8,
		gen_rtx_SET (operand0,
	gen_rtx_PLUS (SImode,
	gen_rtx_PLUS (SImode,
	operand3,
	gen_rtx_ASHIFT (SImode,
	operand2,
	const1_rtx)),
	const_int_rtx[MAX_SAVED_CONST_INT + (2)])),
		gen_rtx_SET (operand1,
	gen_rtx_PLUS (SImode,
	gen_rtx_PLUS (SImode,
	operand4,
	gen_rtx_ASHIFT (SImode,
	copy_rtx (operand2),
	const1_rtx)),
	const_int_rtx[MAX_SAVED_CONST_INT + (2)])),
		gen_rtx_SET (gen_rtx_MEM (BLKmode,
	copy_rtx (operand3)),
	gen_rtx_MEM (BLKmode,
	copy_rtx (operand4))),
		gen_rtx_USE (VOIDmode,
	copy_rtx (operand2)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (HImode)),
		gen_hard_reg_clobber (SImode, 45),
		gen_hard_reg_clobber (SImode, 47),
		gen_hard_reg_clobber (SImode, 49)));
}

/* ../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md:2358 */
rtx
gen_compare_eq (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_EQ (BImode,
	operand1,
	operand2));
}

/* ../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md:2374 */
rtx
gen_compare_lt (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_LT (BImode,
	operand1,
	operand2));
}

/* ../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md:2382 */
rtx
gen_compare_le (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_LE (BImode,
	operand1,
	operand2));
}

/* ../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md:2390 */
rtx
gen_compare_leu (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_LEU (BImode,
	operand1,
	operand2));
}

/* ../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md:2398 */
rtx
gen_compare_ltu (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_LTU (BImode,
	operand1,
	operand2));
}

/* ../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md:2408 */
rtx
gen_flag_mul_macv2hi_parts_acconly_andcc0 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED,
	rtx operand4 ATTRIBUTE_UNUSED,
	rtx operand5 ATTRIBUTE_UNUSED,
	rtx operand6 ATTRIBUTE_UNUSED,
	rtx operand7 ATTRIBUTE_UNUSED,
	rtx operand8 ATTRIBUTE_UNUSED,
	rtx operand9 ATTRIBUTE_UNUSED,
	rtx operand10 ATTRIBUTE_UNUSED,
	rtx operand11 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (PDImode,
	gen_rtvec (3,
		gen_rtx_VEC_SELECT (HImode,
	operand2,
	gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (1,
		operand4))),
		gen_rtx_VEC_SELECT (HImode,
	operand3,
	gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (1,
		operand6))),
		operand10),
	6)),
		gen_rtx_SET (operand1,
	gen_rtx_UNSPEC (PDImode,
	gen_rtvec (5,
		gen_rtx_VEC_SELECT (HImode,
	copy_rtx (operand2),
	gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (1,
		operand5))),
		gen_rtx_VEC_SELECT (HImode,
	copy_rtx (operand3),
	gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (1,
		operand7))),
		operand8,
		operand9,
		operand11),
	7)),
		gen_rtx_SET (gen_rtx_REG (BImode,
	34),
	gen_rtx_AND (BImode,
	gen_rtx_REG (BImode,
	34),
	gen_rtx_UNSPEC (BImode,
	gen_rtvec (3,
		gen_rtx_VEC_SELECT (HImode,
	copy_rtx (operand2),
	gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (1,
		copy_rtx (operand4)))),
		gen_rtx_VEC_SELECT (HImode,
	copy_rtx (operand3),
	gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (1,
		copy_rtx (operand6)))),
		copy_rtx (operand10)),
	6)))));
}

/* ../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md:2485 */
rtx
gen_cbranchbi4 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_fmt_ee (GET_CODE (operand0), VOIDmode,
		operand1,
		operand2),
	gen_rtx_LABEL_REF (VOIDmode,
	operand3),
	pc_rtx));
}

/* ../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md:2503 */
rtx
gen_cbranch_predicted_taken (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_fmt_ee (GET_CODE (operand0), VOIDmode,
		operand1,
		operand2),
	gen_rtx_LABEL_REF (VOIDmode,
	operand3),
	pc_rtx)),
		gen_rtx_UNSPEC (VOIDmode,
	gen_rtvec (1,
		const0_rtx),
	0)));
}

/* ../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md:2519 */
rtx
gen_cbranch_with_nops (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED,
	rtx operand4 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_fmt_ee (GET_CODE (operand0), VOIDmode,
		operand1,
		operand2),
	gen_rtx_LABEL_REF (VOIDmode,
	operand3),
	pc_rtx)),
		gen_rtx_UNSPEC (VOIDmode,
	gen_rtvec (1,
		operand4),
	1)));
}

/* ../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md:2581 */
rtx
gen_nop (void)
{
  return const0_rtx;
}

/* ../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md:2587 */
rtx
gen_forced_nop (void)
{
  return gen_rtx_UNSPEC (VOIDmode,
	gen_rtvec (1,
		const0_rtx),
	12);
}

/* ../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md:2592 */
rtx
gen_mnop (void)
{
  return gen_rtx_UNSPEC (VOIDmode,
	gen_rtvec (1,
		const0_rtx),
	11);
}

/* ../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md:2599 */
rtx
gen_movsibi (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_NE (BImode,
	operand1,
	const0_rtx));
}

/* ../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md:2607 */
rtx
gen_movbisi (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_NE (SImode,
	operand1,
	const0_rtx));
}

/* ../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md:2618 */
rtx
gen_notbi (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_EQ (BImode,
	operand1,
	const0_rtx));
}

/* ../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md:2685 */
rtx
gen_eh_store_handler (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_UNSPEC_VOLATILE (VOIDmode,
	gen_rtvec (1,
		operand1),
	4),
		gen_rtx_CLOBBER (VOIDmode,
	operand0)));
}

