/* Generated automatically by the program `genextract'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "diagnostic-core.h"

/* This variable is used as the "location" of any missing operand
   whose numbers are skipped by a given pattern.  */
static rtx junk ATTRIBUTE_UNUSED;

void
insn_extract (rtx_insn *insn)
{
  rtx *ro = recog_data.operand;
  rtx **ro_loc = recog_data.operand_loc;
  rtx pat = PATTERN (insn);
  int i ATTRIBUTE_UNUSED; /* only for peepholes */

  if (flag_checking)
    {
      memset (ro, 0xab, sizeof (*ro) * MAX_RECOG_OPERANDS);
      memset (ro_loc, 0xab, sizeof (*ro_loc) * MAX_RECOG_OPERANDS);
    }

  switch (INSN_CODE (insn))
    {
    default:
      /* Control reaches here if insn_extract has been called with an
         unrecognizable insn (code -1), or an insn whose INSN_CODE
         corresponds to a DEFINE_EXPAND in the machine description;
         either way, a bug.  */
      if (INSN_CODE (insn) < 0)
        fatal_insn ("unrecognizable insn:", insn);
      else
        fatal_insn ("insn with invalid code number:", insn);

    case 82:  /* atomic_compare_and_swapdi_1 */
    case 81:  /* atomic_compare_and_swapsi_1 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 2));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (pat, 1), 0, 3));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (pat, 1), 0, 0);
      recog_data.dup_num[0] = 0;
      break;

    case 80:  /* atomic_exchangedi */
    case 79:  /* atomic_exchangesi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 1));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 78:  /* atomic_fetch_xordi */
    case 77:  /* atomic_fetch_xorsi */
    case 76:  /* atomic_fetch_ordi */
    case 75:  /* atomic_fetch_orsi */
    case 74:  /* atomic_fetch_anddi */
    case 73:  /* atomic_fetch_andsi */
    case 72:  /* atomic_fetch_adddi */
    case 71:  /* atomic_fetch_addsi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0), 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0), 0);
      recog_data.dup_num[1] = 1;
      break;

    case 70:  /* atomic_xordi */
    case 69:  /* atomic_xorsi */
    case 68:  /* atomic_ordi */
    case 67:  /* atomic_orsi */
    case 66:  /* atomic_anddi */
    case 65:  /* atomic_andsi */
    case 64:  /* atomic_adddi */
    case 63:  /* atomic_addsi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 1));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0);
      recog_data.dup_num[0] = 0;
      break;

    case 62:  /* ldabsdw */
    case 61:  /* ldabsw */
    case 60:  /* ldabsh */
    case 59:  /* ldabsb */
    case 58:  /* ldinddw */
    case 57:  /* ldindw */
    case 56:  /* ldindh */
    case 55:  /* ldindb */
      ro[0] = *(ro_loc[0] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 1));
      break;

    case 53:  /* call_value_internal */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 54:  /* sibcall */
    case 52:  /* call_internal */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      break;

    case 50:  /* jump */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 49:  /* *branch_on_di */
    case 48:  /* *branch_on_si */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 38:  /* *movdf */
    case 37:  /* *movsf */
    case 36:  /* *movdi */
    case 35:  /* *movsi */
    case 34:  /* *movhi */
    case 33:  /* *movqi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      break;

    case 10:  /* *mulsidi3_zeroextend */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 47:  /* bswapdi2 */
    case 46:  /* bswapsi2 */
    case 45:  /* bswaphi2 */
    case 32:  /* extendqisi2 */
    case 31:  /* extendhisi2 */
    case 30:  /* extendqidi2 */
    case 29:  /* extendhidi2 */
    case 28:  /* *extendsidi2 */
    case 27:  /* zero_extendsidi2 */
    case 26:  /* zero_extendqidi2 */
    case 25:  /* zero_extendhidi2 */
    case 7:  /* negdi2 */
    case 6:  /* negsi2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 44:  /* lshrdi3 */
    case 43:  /* lshrsi3 */
    case 42:  /* ashldi3 */
    case 41:  /* ashlsi3 */
    case 40:  /* ashrdi3 */
    case 39:  /* ashrsi3 */
    case 24:  /* xordi3 */
    case 23:  /* xorsi3 */
    case 22:  /* iordi3 */
    case 21:  /* iorsi3 */
    case 20:  /* anddi3 */
    case 19:  /* andsi3 */
    case 18:  /* moddi3 */
    case 17:  /* modsi3 */
    case 16:  /* umoddi3 */
    case 15:  /* umodsi3 */
    case 14:  /* divdi3 */
    case 13:  /* divsi3 */
    case 12:  /* udivdi3 */
    case 11:  /* udivsi3 */
    case 9:  /* muldi3 */
    case 8:  /* mulsi3 */
    case 5:  /* subdi3 */
    case 4:  /* subsi3 */
    case 3:  /* adddi3 */
    case 2:  /* addsi3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 51:  /* exit */
    case 1:  /* nop */
      break;

    }
}
