/* Generated automatically by the program `genemit'
from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "memmodel.h"
#include "tm_p.h"
#include "flags.h"
#include "insn-config.h"
#include "expmed.h"
#include "dojump.h"
#include "explow.h"
#include "emit-rtl.h"
#include "stmt.h"
#include "expr.h"
#include "insn-codes.h"
#include "optabs.h"
#include "dfp.h"
#include "output.h"
#include "recog.h"
#include "df.h"
#include "resource.h"
#include "reload.h"
#include "diagnostic-core.h"
#include "regs.h"
#include "tm-constrs.h"
#include "ggc.h"
#include "target.h"

/* ../../gcc-14.2.1-20240912/gcc/config/pa/pa.md:7246 */
rtx
gen_blockage (void)
{
  return gen_rtx_UNSPEC_VOLATILE (VOIDmode,
	gen_rtvec (1,
		const_int_rtx[MAX_SAVED_CONST_INT + (2)]),
	0);
}

/* ../../gcc-14.2.1-20240912/gcc/config/pa/pa.md:7252 */
rtx
gen_jump (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (pc_rtx,
	gen_rtx_LABEL_REF (VOIDmode,
	operand0));
}

/* ../../gcc-14.2.1-20240912/gcc/config/pa/pa.md:7276 */
rtx
gen_indirect_jump (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (pc_rtx,
	operand0);
}

/* ../../gcc-14.2.1-20240912/gcc/config/pa/pa.md:7328 */
rtx
gen_indirect_goto (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_UNSPEC (VOIDmode,
	gen_rtvec (1,
		operand0),
	1);
}

/* ../../gcc-14.2.1-20240912/gcc/config/pa/pa.md:7404 */
rtx
gen_casesi32 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (pc_rtx,
	gen_rtx_MEM (SImode,
	gen_rtx_PLUS (SImode,
	gen_rtx_MULT (SImode,
	operand0,
	const_int_rtx[MAX_SAVED_CONST_INT + (4)]),
	gen_rtx_LABEL_REF (VOIDmode,
	operand1)))),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode))));
}

/* ../../gcc-14.2.1-20240912/gcc/config/pa/pa.md:7416 */
rtx
gen_casesi32p (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (pc_rtx,
	gen_rtx_MEM (SImode,
	gen_rtx_PLUS (SImode,
	gen_rtx_MULT (SImode,
	operand0,
	const_int_rtx[MAX_SAVED_CONST_INT + (4)]),
	gen_rtx_LABEL_REF (VOIDmode,
	operand1)))),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode))));
}

/* ../../gcc-14.2.1-20240912/gcc/config/pa/pa.md:7433 */
rtx
gen_casesi64p (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (pc_rtx,
	gen_rtx_MEM (DImode,
	gen_rtx_PLUS (DImode,
	gen_rtx_MULT (DImode,
	operand0,
	const_int_rtx[MAX_SAVED_CONST_INT + (8)]),
	gen_rtx_LABEL_REF (VOIDmode,
	operand1)))),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (DImode)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (DImode))));
}

/* ../../gcc-14.2.1-20240912/gcc/config/pa/pa.md:7598 */
rtx
gen_call_symref (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_CALL (VOIDmode,
	gen_rtx_MEM (SImode,
	operand0),
	operand1),
		gen_hard_reg_clobber (SImode, 1),
		gen_hard_reg_clobber (SImode, 2),
		gen_rtx_USE (VOIDmode,
	const0_rtx)));
}

/* ../../gcc-14.2.1-20240912/gcc/config/pa/pa.md:7615 */
rtx
gen_call_symref_pic (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (6,
		gen_rtx_CALL (VOIDmode,
	gen_rtx_MEM (SImode,
	operand0),
	operand1),
		gen_hard_reg_clobber (SImode, 1),
		gen_hard_reg_clobber (SImode, 2),
		gen_rtx_CLOBBER (VOIDmode,
	operand2),
		gen_rtx_USE (VOIDmode,
	gen_rtx_REG (SImode,
	19)),
		gen_rtx_USE (VOIDmode,
	const0_rtx)));
}

/* ../../gcc-14.2.1-20240912/gcc/config/pa/pa.md:7774 */
rtx
gen_call_reg (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_CALL (VOIDmode,
	gen_rtx_MEM (SImode,
	gen_rtx_REG (SImode,
	22)),
	operand0),
		gen_hard_reg_clobber (SImode, 1),
		gen_hard_reg_clobber (SImode, 2),
		gen_rtx_USE (VOIDmode,
	const1_rtx)));
}

/* ../../gcc-14.2.1-20240912/gcc/config/pa/pa.md:7792 */
rtx
gen_call_reg_pic (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (6,
		gen_rtx_CALL (VOIDmode,
	gen_rtx_MEM (SImode,
	gen_rtx_REG (SImode,
	22)),
	operand0),
		gen_hard_reg_clobber (SImode, 1),
		gen_hard_reg_clobber (SImode, 2),
		gen_rtx_CLOBBER (VOIDmode,
	operand1),
		gen_rtx_USE (VOIDmode,
	gen_rtx_REG (SImode,
	19)),
		gen_rtx_USE (VOIDmode,
	const1_rtx)));
}

/* ../../gcc-14.2.1-20240912/gcc/config/pa/pa.md:8085 */
rtx
gen_call_val_symref (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	gen_rtx_CALL (VOIDmode,
	gen_rtx_MEM (SImode,
	operand1),
	operand2)),
		gen_hard_reg_clobber (SImode, 1),
		gen_hard_reg_clobber (SImode, 2),
		gen_rtx_USE (VOIDmode,
	const0_rtx)));
}

/* ../../gcc-14.2.1-20240912/gcc/config/pa/pa.md:8123 */
rtx
gen_call_val_symref_pic (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (6,
		gen_rtx_SET (operand0,
	gen_rtx_CALL (VOIDmode,
	gen_rtx_MEM (SImode,
	operand1),
	operand2)),
		gen_hard_reg_clobber (SImode, 1),
		gen_hard_reg_clobber (SImode, 2),
		gen_rtx_CLOBBER (VOIDmode,
	operand3),
		gen_rtx_USE (VOIDmode,
	gen_rtx_REG (SImode,
	19)),
		gen_rtx_USE (VOIDmode,
	const0_rtx)));
}

/* ../../gcc-14.2.1-20240912/gcc/config/pa/pa.md:8477 */
rtx
gen_call_val_reg (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	gen_rtx_CALL (VOIDmode,
	gen_rtx_MEM (SImode,
	gen_rtx_REG (SImode,
	22)),
	operand1)),
		gen_hard_reg_clobber (SImode, 1),
		gen_hard_reg_clobber (SImode, 2),
		gen_rtx_USE (VOIDmode,
	const1_rtx)));
}

/* ../../gcc-14.2.1-20240912/gcc/config/pa/pa.md:8496 */
rtx
gen_call_val_reg_pic (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (6,
		gen_rtx_SET (operand0,
	gen_rtx_CALL (VOIDmode,
	gen_rtx_MEM (SImode,
	gen_rtx_REG (SImode,
	22)),
	operand1)),
		gen_hard_reg_clobber (SImode, 1),
		gen_hard_reg_clobber (SImode, 2),
		gen_rtx_CLOBBER (VOIDmode,
	operand2),
		gen_rtx_USE (VOIDmode,
	gen_rtx_REG (SImode,
	19)),
		gen_rtx_USE (VOIDmode,
	const1_rtx)));
}

/* ../../gcc-14.2.1-20240912/gcc/config/pa/pa.md:8699 */
rtx
gen_call_mcount_nonpic (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_CALL (VOIDmode,
	gen_rtx_MEM (SImode,
	operand0),
	operand1),
		gen_rtx_SET (gen_rtx_REG (SImode,
	25),
	gen_rtx_PLUS (SImode,
	gen_rtx_REG (SImode,
	2),
	gen_rtx_MINUS (SImode,
	operand2,
	gen_rtx_PLUS (SImode,
	pc_rtx,
	const_int_rtx[MAX_SAVED_CONST_INT + (4)])))),
		gen_hard_reg_clobber (SImode, 2)));
}

/* ../../gcc-14.2.1-20240912/gcc/config/pa/pa.md:8716 */
rtx
gen_call_mcount_pic (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_CALL (VOIDmode,
	gen_rtx_MEM (SImode,
	operand0),
	operand1),
		gen_rtx_SET (gen_rtx_REG (SImode,
	25),
	gen_rtx_PLUS (SImode,
	gen_rtx_REG (SImode,
	2),
	gen_rtx_MINUS (SImode,
	operand2,
	gen_rtx_PLUS (SImode,
	pc_rtx,
	const_int_rtx[MAX_SAVED_CONST_INT + (4)])))),
		gen_hard_reg_clobber (SImode, 2),
		gen_rtx_CLOBBER (VOIDmode,
	operand3),
		gen_rtx_USE (VOIDmode,
	gen_rtx_REG (SImode,
	19))));
}

/* ../../gcc-14.2.1-20240912/gcc/config/pa/pa.md:8903 */
rtx
gen_sibcall_internal_symref (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_CALL (VOIDmode,
	gen_rtx_MEM (SImode,
	operand0),
	operand1),
		gen_hard_reg_clobber (SImode, 1),
		gen_rtx_USE (VOIDmode,
	gen_rtx_REG (SImode,
	2)),
		gen_rtx_USE (VOIDmode,
	const0_rtx)));
}

/* ../../gcc-14.2.1-20240912/gcc/config/pa/pa.md:8989 */
rtx
gen_sibcall_value_internal_symref (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	gen_rtx_CALL (VOIDmode,
	gen_rtx_MEM (SImode,
	operand1),
	operand2)),
		gen_hard_reg_clobber (SImode, 1),
		gen_rtx_USE (VOIDmode,
	gen_rtx_REG (SImode,
	2)),
		gen_rtx_USE (VOIDmode,
	const0_rtx)));
}

/* ../../gcc-14.2.1-20240912/gcc/config/pa/pa.md:9024 */
rtx
gen_nop (void)
{
  return const0_rtx;
}

/* ../../gcc-14.2.1-20240912/gcc/config/pa/pa.md:9149 */
rtx
gen_extzv_32 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_ZERO_EXTRACT (SImode,
	operand1,
	operand2,
	operand3));
}

/* ../../gcc-14.2.1-20240912/gcc/config/pa/pa.md:9249 */
rtx
gen_extv_32 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_SIGN_EXTRACT (SImode,
	operand1,
	operand2,
	operand3));
}

/* ../../gcc-14.2.1-20240912/gcc/config/pa/pa.md:9349 */
rtx
gen_insv_32 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (gen_rtx_ZERO_EXTRACT (SImode,
	operand0,
	operand1,
	operand2),
	operand3);
}

/* ../../gcc-14.2.1-20240912/gcc/config/pa/pa.md:9452 */
rtx
gen_decrement_and_branch_until_zero (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_fmt_ee (GET_CODE (operand2), VOIDmode,
		gen_rtx_PLUS (SImode,
	operand0,
	operand1),
		const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand3),
	pc_rtx)),
		gen_rtx_SET (copy_rtx (operand0),
	gen_rtx_PLUS (SImode,
	copy_rtx (operand0),
	copy_rtx (operand1))),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode))));
}

/* ../../gcc-14.2.1-20240912/gcc/config/pa/pa.md:9909 */
rtx
gen_dcacheflushsi (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (6,
		const1_rtx,
		gen_rtx_UNSPEC_VOLATILE (VOIDmode,
	gen_rtvec (1,
		gen_rtx_MEM (BLKmode,
	gen_rtx_SCRATCH (VOIDmode))),
	1),
		gen_rtx_USE (VOIDmode,
	operand0),
		gen_rtx_USE (VOIDmode,
	operand1),
		gen_rtx_USE (VOIDmode,
	operand2),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode))));
}

/* ../../gcc-14.2.1-20240912/gcc/config/pa/pa.md:9909 */
rtx
gen_dcacheflushdi (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (6,
		const1_rtx,
		gen_rtx_UNSPEC_VOLATILE (VOIDmode,
	gen_rtvec (1,
		gen_rtx_MEM (BLKmode,
	gen_rtx_SCRATCH (VOIDmode))),
	1),
		gen_rtx_USE (VOIDmode,
	operand0),
		gen_rtx_USE (VOIDmode,
	operand1),
		gen_rtx_USE (VOIDmode,
	operand2),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (DImode))));
}

/* ../../gcc-14.2.1-20240912/gcc/config/pa/pa.md:9921 */
rtx
gen_icacheflushsi (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED,
	rtx operand4 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (8,
		const_int_rtx[MAX_SAVED_CONST_INT + (2)],
		gen_rtx_UNSPEC_VOLATILE (VOIDmode,
	gen_rtvec (1,
		gen_rtx_MEM (BLKmode,
	gen_rtx_SCRATCH (VOIDmode))),
	2),
		gen_rtx_USE (VOIDmode,
	operand0),
		gen_rtx_USE (VOIDmode,
	operand1),
		gen_rtx_USE (VOIDmode,
	operand2),
		gen_rtx_CLOBBER (VOIDmode,
	operand3),
		gen_rtx_CLOBBER (VOIDmode,
	operand4),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode))));
}

/* ../../gcc-14.2.1-20240912/gcc/config/pa/pa.md:9921 */
rtx
gen_icacheflushdi (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED,
	rtx operand4 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (8,
		const_int_rtx[MAX_SAVED_CONST_INT + (2)],
		gen_rtx_UNSPEC_VOLATILE (VOIDmode,
	gen_rtvec (1,
		gen_rtx_MEM (BLKmode,
	gen_rtx_SCRATCH (VOIDmode))),
	2),
		gen_rtx_USE (VOIDmode,
	operand0),
		gen_rtx_USE (VOIDmode,
	operand1),
		gen_rtx_USE (VOIDmode,
	operand2),
		gen_rtx_CLOBBER (VOIDmode,
	operand3),
		gen_rtx_CLOBBER (VOIDmode,
	operand4),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (DImode))));
}

/* ../../gcc-14.2.1-20240912/gcc/config/pa/pa.md:9953 */
rtx
gen_outline_prologue_call (void)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (7,
		gen_rtx_UNSPEC_VOLATILE (VOIDmode,
	gen_rtvec (1,
		const0_rtx),
	3),
		gen_hard_reg_clobber (SImode, 31),
		gen_hard_reg_clobber (SImode, 22),
		gen_hard_reg_clobber (SImode, 21),
		gen_hard_reg_clobber (SImode, 20),
		gen_hard_reg_clobber (SImode, 19),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc-14.2.1-20240912/gcc/config/pa/pa.md:10002 */
rtx
gen_outline_epilogue_call (void)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (10,
		gen_rtx_UNSPEC_VOLATILE (VOIDmode,
	gen_rtvec (1,
		const1_rtx),
	4),
		gen_rtx_USE (VOIDmode,
	gen_rtx_REG (SImode,
	29)),
		gen_rtx_USE (VOIDmode,
	gen_rtx_REG (SImode,
	28)),
		gen_hard_reg_clobber (SImode, 31),
		gen_hard_reg_clobber (SImode, 22),
		gen_hard_reg_clobber (SImode, 21),
		gen_hard_reg_clobber (SImode, 20),
		gen_hard_reg_clobber (SImode, 19),
		gen_hard_reg_clobber (SImode, 2),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc-14.2.1-20240912/gcc/config/pa/pa.md:10225 */
rtx
gen_prefetch_20 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PREFETCH (VOIDmode,
	operand0,
	operand1,
	operand2);
}

/* ../../gcc-14.2.1-20240912/gcc/config/pa/pa.md:10254 */
rtx
gen_tgd_load (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		operand1),
	4)),
		gen_hard_reg_clobber (SImode, 1),
		gen_rtx_USE (VOIDmode,
	gen_rtx_REG (SImode,
	27))));
}

/* ../../gcc-14.2.1-20240912/gcc/config/pa/pa.md:10280 */
rtx
gen_tgd_load_picsi (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		operand1),
	10)),
		gen_hard_reg_clobber (SImode, 1),
		gen_rtx_USE (VOIDmode,
	gen_rtx_REG (SImode,
	19))));
}

/* ../../gcc-14.2.1-20240912/gcc/config/pa/pa.md:10306 */
rtx
gen_tld_load (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		operand1),
	5)),
		gen_hard_reg_clobber (SImode, 1),
		gen_rtx_USE (VOIDmode,
	gen_rtx_REG (SImode,
	27))));
}

/* ../../gcc-14.2.1-20240912/gcc/config/pa/pa.md:10332 */
rtx
gen_tld_load_picsi (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		operand1),
	11)),
		gen_hard_reg_clobber (SImode, 1),
		gen_rtx_USE (VOIDmode,
	gen_rtx_REG (SImode,
	19))));
}

/* ../../gcc-14.2.1-20240912/gcc/config/pa/pa.md:10373 */
rtx
gen_tld_offset_loadsi (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (operand0,
	gen_rtx_PLUS (SImode,
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		operand1),
	6),
	operand2)),
		gen_hard_reg_clobber (SImode, 1)));
}

