/* Generated automatically by the program `genopinit'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "memmodel.h"
#include "tm_p.h"
#include "flags.h"
#include "insn-config.h"
#include "expmed.h"
#include "dojump.h"
#include "explow.h"
#include "emit-rtl.h"
#include "stmt.h"
#include "expr.h"
#include "insn-codes.h"
#include "optabs.h"

struct optab_pat {
  unsigned scode;
  enum insn_code icode;
};

static const struct optab_pat pats[NUM_OPTAB_PATTERNS] = {
  { 0x10340e, CODE_FOR_extendqihi2 },
  { 0x10340f, CODE_FOR_extendqisi2 },
  { 0x103410, CODE_FOR_extendqidi2 },
  { 0x10380f, CODE_FOR_extendhisi2 },
  { 0x103810, CODE_FOR_extendhidi2 },
  { 0x103c10, CODE_FOR_extendsidi2 },
  { 0x109426, CODE_FOR_extendsfdf2 },
  { 0x109427, CODE_FOR_extendsftf2 },
  { 0x109827, CODE_FOR_extenddftf2 },
  { 0x209825, CODE_FOR_truncdfsf2 },
  { 0x209c25, CODE_FOR_trunctfsf2 },
  { 0x209c26, CODE_FOR_trunctfdf2 },
  { 0x30340e, CODE_FOR_zero_extendqihi2 },
  { 0x30340f, CODE_FOR_zero_extendqisi2 },
  { 0x303410, CODE_FOR_zero_extendqidi2 },
  { 0x30380f, CODE_FOR_zero_extendhisi2 },
  { 0x303810, CODE_FOR_zero_extendhidi2 },
  { 0x303c10, CODE_FOR_zero_extendsidi2 },
  { 0x603c25, CODE_FOR_floatsisf2 },
  { 0x603c26, CODE_FOR_floatsidf2 },
  { 0x603c27, CODE_FOR_floatsitf2 },
  { 0x604025, CODE_FOR_floatdisf2 },
  { 0x604026, CODE_FOR_floatdidf2 },
  { 0x604027, CODE_FOR_floatditf2 },
  { 0x703c27, CODE_FOR_floatunssitf2 },
  { 0x704025, CODE_FOR_floatunsdisf2 },
  { 0x704026, CODE_FOR_floatunsdidf2 },
  { 0x704027, CODE_FOR_floatunsditf2 },
  { 0x100940f, CODE_FOR_fix_truncsfsi2 },
  { 0x1009410, CODE_FOR_fix_truncsfdi2 },
  { 0x100980f, CODE_FOR_fix_truncdfsi2 },
  { 0x1009810, CODE_FOR_fix_truncdfdi2 },
  { 0x1009c0f, CODE_FOR_fix_trunctfsi2 },
  { 0x1009c10, CODE_FOR_fix_trunctfdi2 },
  { 0x1109410, CODE_FOR_fixuns_truncsfdi2 },
  { 0x1109810, CODE_FOR_fixuns_truncdfdi2 },
  { 0x1109c0f, CODE_FOR_fixuns_trunctfsi2 },
  { 0x1109c10, CODE_FOR_fixuns_trunctfdi2 },
  { 0x1203c10, CODE_FOR_mulsidi3 },
  { 0x1303c10, CODE_FOR_umulsidi3 },
  { 0x230dc37, CODE_FOR_vcondv8qiv8qi },
  { 0x230e038, CODE_FOR_vcondv4hiv4hi },
  { 0x230e439, CODE_FOR_vcondv2siv2si },
  { 0x240dc37, CODE_FOR_vconduv8qiv8qi },
  { 0x240e038, CODE_FOR_vconduv4hiv4hi },
  { 0x240e439, CODE_FOR_vconduv2siv2si },
  { 0x3503434, CODE_FOR_vec_initv4qiqi },
  { 0x3503437, CODE_FOR_vec_initv8qiqi },
  { 0x3503835, CODE_FOR_vec_initv2hihi },
  { 0x3503838, CODE_FOR_vec_initv4hihi },
  { 0x3503c36, CODE_FOR_vec_initv1sisi },
  { 0x3503c39, CODE_FOR_vec_initv2sisi },
  { 0x350403a, CODE_FOR_vec_initv1didi },
  { 0x370000f, CODE_FOR_addsi3 },
  { 0x3700010, CODE_FOR_adddi3 },
  { 0x3700025, CODE_FOR_addsf3 },
  { 0x3700026, CODE_FOR_adddf3 },
  { 0x3700027, CODE_FOR_addtf3 },
  { 0x3700035, CODE_FOR_addv2hi3 },
  { 0x3700036, CODE_FOR_addv1si3 },
  { 0x3700037, CODE_FOR_addv8qi3 },
  { 0x3700038, CODE_FOR_addv4hi3 },
  { 0x3700039, CODE_FOR_addv2si3 },
  { 0x3b0000f, CODE_FOR_subsi3 },
  { 0x3b00010, CODE_FOR_subdi3 },
  { 0x3b00025, CODE_FOR_subsf3 },
  { 0x3b00026, CODE_FOR_subdf3 },
  { 0x3b00027, CODE_FOR_subtf3 },
  { 0x3b00035, CODE_FOR_subv2hi3 },
  { 0x3b00036, CODE_FOR_subv1si3 },
  { 0x3b00037, CODE_FOR_subv8qi3 },
  { 0x3b00038, CODE_FOR_subv4hi3 },
  { 0x3b00039, CODE_FOR_subv2si3 },
  { 0x3f0000f, CODE_FOR_mulsi3 },
  { 0x3f00010, CODE_FOR_muldi3 },
  { 0x3f00025, CODE_FOR_mulsf3 },
  { 0x3f00026, CODE_FOR_muldf3 },
  { 0x3f00027, CODE_FOR_multf3 },
  { 0x430000f, CODE_FOR_divsi3 },
  { 0x4300010, CODE_FOR_divdi3 },
  { 0x4300025, CODE_FOR_divsf3 },
  { 0x4300026, CODE_FOR_divdf3 },
  { 0x4300027, CODE_FOR_divtf3 },
  { 0x460000f, CODE_FOR_udivsi3 },
  { 0x4600010, CODE_FOR_udivdi3 },
  { 0x4d0000f, CODE_FOR_andsi3 },
  { 0x4d00010, CODE_FOR_anddi3 },
  { 0x4d00034, CODE_FOR_andv4qi3 },
  { 0x4d00035, CODE_FOR_andv2hi3 },
  { 0x4d00036, CODE_FOR_andv1si3 },
  { 0x4d00037, CODE_FOR_andv8qi3 },
  { 0x4d00038, CODE_FOR_andv4hi3 },
  { 0x4d00039, CODE_FOR_andv2si3 },
  { 0x4d0003a, CODE_FOR_andv1di3 },
  { 0x4e0000f, CODE_FOR_iorsi3 },
  { 0x4e00010, CODE_FOR_iordi3 },
  { 0x4e00034, CODE_FOR_iorv4qi3 },
  { 0x4e00035, CODE_FOR_iorv2hi3 },
  { 0x4e00036, CODE_FOR_iorv1si3 },
  { 0x4e00037, CODE_FOR_iorv8qi3 },
  { 0x4e00038, CODE_FOR_iorv4hi3 },
  { 0x4e00039, CODE_FOR_iorv2si3 },
  { 0x4e0003a, CODE_FOR_iorv1di3 },
  { 0x4f0000f, CODE_FOR_xorsi3 },
  { 0x4f00010, CODE_FOR_xordi3 },
  { 0x4f00034, CODE_FOR_xorv4qi3 },
  { 0x4f00035, CODE_FOR_xorv2hi3 },
  { 0x4f00036, CODE_FOR_xorv1si3 },
  { 0x4f00037, CODE_FOR_xorv8qi3 },
  { 0x4f00038, CODE_FOR_xorv4hi3 },
  { 0x4f00039, CODE_FOR_xorv2si3 },
  { 0x4f0003a, CODE_FOR_xorv1di3 },
  { 0x500000f, CODE_FOR_ashlsi3 },
  { 0x5000010, CODE_FOR_ashldi3 },
  { 0x530000f, CODE_FOR_ashrsi3 },
  { 0x5300010, CODE_FOR_ashrdi3 },
  { 0x540000f, CODE_FOR_lshrsi3 },
  { 0x5400010, CODE_FOR_lshrdi3 },
  { 0x5700038, CODE_FOR_vashlv4hi3 },
  { 0x5700039, CODE_FOR_vashlv2si3 },
  { 0x5800038, CODE_FOR_vashrv4hi3 },
  { 0x5800039, CODE_FOR_vashrv2si3 },
  { 0x5900038, CODE_FOR_vlshrv4hi3 },
  { 0x5900039, CODE_FOR_vlshrv2si3 },
  { 0x600000f, CODE_FOR_negsi2 },
  { 0x6000010, CODE_FOR_negdi2 },
  { 0x6000025, CODE_FOR_negsf2 },
  { 0x6000026, CODE_FOR_negdf2 },
  { 0x6000027, CODE_FOR_negtf2 },
  { 0x6400025, CODE_FOR_abssf2 },
  { 0x6400026, CODE_FOR_absdf2 },
  { 0x6400027, CODE_FOR_abstf2 },
  { 0x660000f, CODE_FOR_one_cmplsi2 },
  { 0x6600010, CODE_FOR_one_cmpldi2 },
  { 0x6600034, CODE_FOR_one_cmplv4qi2 },
  { 0x6600035, CODE_FOR_one_cmplv2hi2 },
  { 0x6600036, CODE_FOR_one_cmplv1si2 },
  { 0x6600037, CODE_FOR_one_cmplv8qi2 },
  { 0x6600038, CODE_FOR_one_cmplv4hi2 },
  { 0x6600039, CODE_FOR_one_cmplv2si2 },
  { 0x660003a, CODE_FOR_one_cmplv1di2 },
  { 0x690000f, CODE_FOR_clzsi2 },
  { 0x6900010, CODE_FOR_clzdi2 },
  { 0x6c0000f, CODE_FOR_popcountsi2 },
  { 0x6c00010, CODE_FOR_popcountdi2 },
  { 0x7800025, CODE_FOR_sqrtsf2 },
  { 0x7800026, CODE_FOR_sqrtdf2 },
  { 0x7800027, CODE_FOR_sqrttf2 },
  { 0x870000d, CODE_FOR_movqi },
  { 0x870000e, CODE_FOR_movhi },
  { 0x870000f, CODE_FOR_movsi },
  { 0x8700010, CODE_FOR_movdi },
  { 0x8700011, CODE_FOR_movti },
  { 0x8700025, CODE_FOR_movsf },
  { 0x8700026, CODE_FOR_movdf },
  { 0x8700027, CODE_FOR_movtf },
  { 0x8700034, CODE_FOR_movv4qi },
  { 0x8700035, CODE_FOR_movv2hi },
  { 0x8700036, CODE_FOR_movv1si },
  { 0x8700037, CODE_FOR_movv8qi },
  { 0x8700038, CODE_FOR_movv4hi },
  { 0x8700039, CODE_FOR_movv2si },
  { 0x870003a, CODE_FOR_movv1di },
  { 0x9200010, CODE_FOR_reload_indi },
  { 0x9300010, CODE_FOR_reload_outdi },
  { 0x9400002, CODE_FOR_cbranchcc4 },
  { 0x940000f, CODE_FOR_cbranchsi4 },
  { 0x9400010, CODE_FOR_cbranchdi4 },
  { 0x9400025, CODE_FOR_cbranchsf4 },
  { 0x9400026, CODE_FOR_cbranchdf4 },
  { 0x9400027, CODE_FOR_cbranchtf4 },
  { 0x9a0000d, CODE_FOR_movqicc },
  { 0x9a0000e, CODE_FOR_movhicc },
  { 0x9a0000f, CODE_FOR_movsicc },
  { 0x9a00010, CODE_FOR_movdicc },
  { 0x9a00025, CODE_FOR_movsfcc },
  { 0x9a00026, CODE_FOR_movdfcc },
  { 0x9a00027, CODE_FOR_movtfcc },
  { 0xd10000f, CODE_FOR_cstoresi4 },
  { 0xd100010, CODE_FOR_cstoredi4 },
  { 0xd100025, CODE_FOR_cstoresf4 },
  { 0xd100026, CODE_FOR_cstoredf4 },
  { 0xd100027, CODE_FOR_cstoretf4 },
  { 0xd20000f, CODE_FOR_ctrapsi4 },
  { 0xd200010, CODE_FOR_ctrapdi4 },
  { 0xd30000f, CODE_FOR_addvsi4 },
  { 0xd300010, CODE_FOR_addvdi4 },
  { 0xd40000f, CODE_FOR_subvsi4 },
  { 0xd400010, CODE_FOR_subvdi4 },
  { 0xd60000f, CODE_FOR_uaddvsi4 },
  { 0xd600010, CODE_FOR_uaddvdi4 },
  { 0xd70000f, CODE_FOR_usubvsi4 },
  { 0xd700010, CODE_FOR_usubvdi4 },
  { 0xd90000f, CODE_FOR_negvsi3 },
  { 0xd900010, CODE_FOR_negvdi3 },
  { 0xde0000f, CODE_FOR_smulsi3_highpart },
  { 0xdf0000f, CODE_FOR_umulsi3_highpart },
  { 0xe800025, CODE_FOR_fmasf4 },
  { 0xe800026, CODE_FOR_fmadf4 },
  { 0xe900025, CODE_FOR_fmssf4 },
  { 0xe900026, CODE_FOR_fmsdf4 },
  { 0x14f00037, CODE_FOR_vec_permv8qi },
  { 0x14f00038, CODE_FOR_vec_permv4hi },
  { 0x14f00039, CODE_FOR_vec_permv2si },
  { 0x14f0003a, CODE_FOR_vec_permv1di },
  { 0x19d0000d, CODE_FOR_atomic_compare_and_swapqi },
  { 0x19d0000e, CODE_FOR_atomic_compare_and_swaphi },
  { 0x19d0000f, CODE_FOR_atomic_compare_and_swapsi },
  { 0x19d00010, CODE_FOR_atomic_compare_and_swapdi },
  { 0x19e0000f, CODE_FOR_atomic_exchangesi },
  { 0x1a50000d, CODE_FOR_atomic_loadqi },
  { 0x1a50000e, CODE_FOR_atomic_loadhi },
  { 0x1a50000f, CODE_FOR_atomic_loadsi },
  { 0x1a500010, CODE_FOR_atomic_loaddi },
  { 0x1aa0000d, CODE_FOR_atomic_storeqi },
  { 0x1aa0000e, CODE_FOR_atomic_storehi },
  { 0x1aa0000f, CODE_FOR_atomic_storesi },
  { 0x1aa00010, CODE_FOR_atomic_storedi },
};

void
init_all_optabs (struct target_optabs *optabs)
{
  bool *ena = optabs->pat_enable;
  ena[0] = HAVE_extendqihi2;
  ena[1] = HAVE_extendqisi2;
  ena[2] = HAVE_extendqidi2;
  ena[3] = HAVE_extendhisi2;
  ena[4] = HAVE_extendhidi2;
  ena[5] = HAVE_extendsidi2;
  ena[6] = HAVE_extendsfdf2;
  ena[7] = HAVE_extendsftf2;
  ena[8] = HAVE_extenddftf2;
  ena[9] = HAVE_truncdfsf2;
  ena[10] = HAVE_trunctfsf2;
  ena[11] = HAVE_trunctfdf2;
  ena[12] = HAVE_zero_extendqihi2;
  ena[13] = HAVE_zero_extendqisi2;
  ena[14] = HAVE_zero_extendqidi2;
  ena[15] = HAVE_zero_extendhisi2;
  ena[16] = HAVE_zero_extendhidi2;
  ena[17] = HAVE_zero_extendsidi2;
  ena[18] = HAVE_floatsisf2;
  ena[19] = HAVE_floatsidf2;
  ena[20] = HAVE_floatsitf2;
  ena[21] = HAVE_floatdisf2;
  ena[22] = HAVE_floatdidf2;
  ena[23] = HAVE_floatditf2;
  ena[24] = HAVE_floatunssitf2;
  ena[25] = HAVE_floatunsdisf2;
  ena[26] = HAVE_floatunsdidf2;
  ena[27] = HAVE_floatunsditf2;
  ena[28] = HAVE_fix_truncsfsi2;
  ena[29] = HAVE_fix_truncsfdi2;
  ena[30] = HAVE_fix_truncdfsi2;
  ena[31] = HAVE_fix_truncdfdi2;
  ena[32] = HAVE_fix_trunctfsi2;
  ena[33] = HAVE_fix_trunctfdi2;
  ena[34] = HAVE_fixuns_truncsfdi2;
  ena[35] = HAVE_fixuns_truncdfdi2;
  ena[36] = HAVE_fixuns_trunctfsi2;
  ena[37] = HAVE_fixuns_trunctfdi2;
  ena[38] = HAVE_mulsidi3;
  ena[39] = HAVE_umulsidi3;
  ena[40] = HAVE_vcondv8qiv8qi;
  ena[41] = HAVE_vcondv4hiv4hi;
  ena[42] = HAVE_vcondv2siv2si;
  ena[43] = HAVE_vconduv8qiv8qi;
  ena[44] = HAVE_vconduv4hiv4hi;
  ena[45] = HAVE_vconduv2siv2si;
  ena[46] = HAVE_vec_initv4qiqi;
  ena[47] = HAVE_vec_initv8qiqi;
  ena[48] = HAVE_vec_initv2hihi;
  ena[49] = HAVE_vec_initv4hihi;
  ena[50] = HAVE_vec_initv1sisi;
  ena[51] = HAVE_vec_initv2sisi;
  ena[52] = HAVE_vec_initv1didi;
  ena[53] = HAVE_addsi3;
  ena[54] = HAVE_adddi3;
  ena[55] = HAVE_addsf3;
  ena[56] = HAVE_adddf3;
  ena[57] = HAVE_addtf3;
  ena[58] = HAVE_addv2hi3;
  ena[59] = HAVE_addv1si3;
  ena[60] = HAVE_addv8qi3;
  ena[61] = HAVE_addv4hi3;
  ena[62] = HAVE_addv2si3;
  ena[63] = HAVE_subsi3;
  ena[64] = HAVE_subdi3;
  ena[65] = HAVE_subsf3;
  ena[66] = HAVE_subdf3;
  ena[67] = HAVE_subtf3;
  ena[68] = HAVE_subv2hi3;
  ena[69] = HAVE_subv1si3;
  ena[70] = HAVE_subv8qi3;
  ena[71] = HAVE_subv4hi3;
  ena[72] = HAVE_subv2si3;
  ena[73] = HAVE_mulsi3;
  ena[74] = HAVE_muldi3;
  ena[75] = HAVE_mulsf3;
  ena[76] = HAVE_muldf3;
  ena[77] = HAVE_multf3;
  ena[78] = HAVE_divsi3;
  ena[79] = HAVE_divdi3;
  ena[80] = HAVE_divsf3;
  ena[81] = HAVE_divdf3;
  ena[82] = HAVE_divtf3;
  ena[83] = HAVE_udivsi3;
  ena[84] = HAVE_udivdi3;
  ena[85] = HAVE_andsi3;
  ena[86] = HAVE_anddi3;
  ena[87] = HAVE_andv4qi3;
  ena[88] = HAVE_andv2hi3;
  ena[89] = HAVE_andv1si3;
  ena[90] = HAVE_andv8qi3;
  ena[91] = HAVE_andv4hi3;
  ena[92] = HAVE_andv2si3;
  ena[93] = HAVE_andv1di3;
  ena[94] = HAVE_iorsi3;
  ena[95] = HAVE_iordi3;
  ena[96] = HAVE_iorv4qi3;
  ena[97] = HAVE_iorv2hi3;
  ena[98] = HAVE_iorv1si3;
  ena[99] = HAVE_iorv8qi3;
  ena[100] = HAVE_iorv4hi3;
  ena[101] = HAVE_iorv2si3;
  ena[102] = HAVE_iorv1di3;
  ena[103] = HAVE_xorsi3;
  ena[104] = HAVE_xordi3;
  ena[105] = HAVE_xorv4qi3;
  ena[106] = HAVE_xorv2hi3;
  ena[107] = HAVE_xorv1si3;
  ena[108] = HAVE_xorv8qi3;
  ena[109] = HAVE_xorv4hi3;
  ena[110] = HAVE_xorv2si3;
  ena[111] = HAVE_xorv1di3;
  ena[112] = HAVE_ashlsi3;
  ena[113] = HAVE_ashldi3;
  ena[114] = HAVE_ashrsi3;
  ena[115] = HAVE_ashrdi3;
  ena[116] = HAVE_lshrsi3;
  ena[117] = HAVE_lshrdi3;
  ena[118] = HAVE_vashlv4hi3;
  ena[119] = HAVE_vashlv2si3;
  ena[120] = HAVE_vashrv4hi3;
  ena[121] = HAVE_vashrv2si3;
  ena[122] = HAVE_vlshrv4hi3;
  ena[123] = HAVE_vlshrv2si3;
  ena[124] = HAVE_negsi2;
  ena[125] = HAVE_negdi2;
  ena[126] = HAVE_negsf2;
  ena[127] = HAVE_negdf2;
  ena[128] = HAVE_negtf2;
  ena[129] = HAVE_abssf2;
  ena[130] = HAVE_absdf2;
  ena[131] = HAVE_abstf2;
  ena[132] = HAVE_one_cmplsi2;
  ena[133] = HAVE_one_cmpldi2;
  ena[134] = HAVE_one_cmplv4qi2;
  ena[135] = HAVE_one_cmplv2hi2;
  ena[136] = HAVE_one_cmplv1si2;
  ena[137] = HAVE_one_cmplv8qi2;
  ena[138] = HAVE_one_cmplv4hi2;
  ena[139] = HAVE_one_cmplv2si2;
  ena[140] = HAVE_one_cmplv1di2;
  ena[141] = HAVE_clzsi2;
  ena[142] = HAVE_clzdi2;
  ena[143] = HAVE_popcountsi2;
  ena[144] = HAVE_popcountdi2;
  ena[145] = HAVE_sqrtsf2;
  ena[146] = HAVE_sqrtdf2;
  ena[147] = HAVE_sqrttf2;
  ena[148] = HAVE_movqi;
  ena[149] = HAVE_movhi;
  ena[150] = HAVE_movsi;
  ena[151] = HAVE_movdi;
  ena[152] = HAVE_movti;
  ena[153] = HAVE_movsf;
  ena[154] = HAVE_movdf;
  ena[155] = HAVE_movtf;
  ena[156] = HAVE_movv4qi;
  ena[157] = HAVE_movv2hi;
  ena[158] = HAVE_movv1si;
  ena[159] = HAVE_movv8qi;
  ena[160] = HAVE_movv4hi;
  ena[161] = HAVE_movv2si;
  ena[162] = HAVE_movv1di;
  ena[163] = HAVE_reload_indi;
  ena[164] = HAVE_reload_outdi;
  ena[165] = HAVE_cbranchcc4;
  ena[166] = HAVE_cbranchsi4;
  ena[167] = HAVE_cbranchdi4;
  ena[168] = HAVE_cbranchsf4;
  ena[169] = HAVE_cbranchdf4;
  ena[170] = HAVE_cbranchtf4;
  ena[171] = HAVE_movqicc;
  ena[172] = HAVE_movhicc;
  ena[173] = HAVE_movsicc;
  ena[174] = HAVE_movdicc;
  ena[175] = HAVE_movsfcc;
  ena[176] = HAVE_movdfcc;
  ena[177] = HAVE_movtfcc;
  ena[178] = HAVE_cstoresi4;
  ena[179] = HAVE_cstoredi4;
  ena[180] = HAVE_cstoresf4;
  ena[181] = HAVE_cstoredf4;
  ena[182] = HAVE_cstoretf4;
  ena[183] = HAVE_ctrapsi4;
  ena[184] = HAVE_ctrapdi4;
  ena[185] = HAVE_addvsi4;
  ena[186] = HAVE_addvdi4;
  ena[187] = HAVE_subvsi4;
  ena[188] = HAVE_subvdi4;
  ena[189] = HAVE_uaddvsi4;
  ena[190] = HAVE_uaddvdi4;
  ena[191] = HAVE_usubvsi4;
  ena[192] = HAVE_usubvdi4;
  ena[193] = HAVE_negvsi3;
  ena[194] = HAVE_negvdi3;
  ena[195] = HAVE_smulsi3_highpart;
  ena[196] = HAVE_umulsi3_highpart;
  ena[197] = HAVE_fmasf4;
  ena[198] = HAVE_fmadf4;
  ena[199] = HAVE_fmssf4;
  ena[200] = HAVE_fmsdf4;
  ena[201] = HAVE_vec_permv8qi;
  ena[202] = HAVE_vec_permv4hi;
  ena[203] = HAVE_vec_permv2si;
  ena[204] = HAVE_vec_permv1di;
  ena[205] = HAVE_atomic_compare_and_swapqi;
  ena[206] = HAVE_atomic_compare_and_swaphi;
  ena[207] = HAVE_atomic_compare_and_swapsi;
  ena[208] = HAVE_atomic_compare_and_swapdi;
  ena[209] = HAVE_atomic_exchangesi;
  ena[210] = HAVE_atomic_loadqi;
  ena[211] = HAVE_atomic_loadhi;
  ena[212] = HAVE_atomic_loadsi;
  ena[213] = HAVE_atomic_loaddi;
  ena[214] = HAVE_atomic_storeqi;
  ena[215] = HAVE_atomic_storehi;
  ena[216] = HAVE_atomic_storesi;
  ena[217] = HAVE_atomic_storedi;
}

/* Returns TRUE if the target supports any of the partial vector
   optabs: while_ult_optab, len_load_optab, len_store_optab,
   mask_len_load_optab or mask_len_store_optab,
   for any mode.  */
bool
partial_vectors_supported_p (void)
{
	return false;
}
static int
lookup_handler (unsigned scode)
{
  int l = 0, h = ARRAY_SIZE (pats), m;
  while (h > l)
    {
      m = (h + l) / 2;
      if (scode == pats[m].scode)
        return m;
      else if (scode < pats[m].scode)
        h = m;
      else
        l = m + 1;
    }
  return -1;
}

enum insn_code
raw_optab_handler (unsigned scode)
{
  int i = lookup_handler (scode);
  return (i >= 0 && this_fn_optabs->pat_enable[i]
          ? pats[i].icode : CODE_FOR_nothing);
}

bool
swap_optab_enable (optab op, machine_mode m, bool set)
{
  unsigned scode = (op << 20) | m;
  int i = lookup_handler (scode);
  if (i >= 0)
    {
      bool ret = this_fn_optabs->pat_enable[i];
      this_fn_optabs->pat_enable[i] = set;
      return ret;
    }
  else
    {
      gcc_assert (!set);
      return false;
    }
}

const struct convert_optab_libcall_d convlib_def[NUM_CONVLIB_OPTABS] = {
  { "extend", gen_extend_conv_libfunc },
  { "trunc", gen_trunc_conv_libfunc },
  { NULL, NULL },
  { "fix", gen_fp_to_int_conv_libfunc },
  { "fixuns", gen_fp_to_int_conv_libfunc },
  { "float", gen_int_to_fp_conv_libfunc },
  { NULL, gen_ufloat_conv_libfunc },
  { "lrint", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lround", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lfloor", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lceil", gen_int_to_fp_nondecimal_conv_libfunc },
  { "fract", gen_fract_conv_libfunc },
  { "fractuns", gen_fractuns_conv_libfunc },
  { "satfract", gen_satfract_conv_libfunc },
  { "satfractuns", gen_satfractuns_conv_libfunc },
};

const struct optab_libcall_d normlib_def[NUM_NORMLIB_OPTABS] = {
  { '3', "add", gen_int_fp_fixed_libfunc },
  { '3', "add", gen_intv_fp_libfunc },
  { '3', "ssadd", gen_signed_fixed_libfunc },
  { '3', "usadd", gen_unsigned_fixed_libfunc },
  { '3', "sub", gen_int_fp_fixed_libfunc },
  { '3', "sub", gen_intv_fp_libfunc },
  { '3', "sssub", gen_signed_fixed_libfunc },
  { '3', "ussub", gen_unsigned_fixed_libfunc },
  { '3', "mul", gen_int_fp_fixed_libfunc },
  { '3', "mul", gen_intv_fp_libfunc },
  { '3', "ssmul", gen_signed_fixed_libfunc },
  { '3', "usmul", gen_unsigned_fixed_libfunc },
  { '3', "div", gen_int_fp_signed_fixed_libfunc },
  { '3', "divv", gen_int_libfunc },
  { '3', "ssdiv", gen_signed_fixed_libfunc },
  { '3', "udiv", gen_int_unsigned_fixed_libfunc },
  { '3', "usdiv", gen_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '3', "mod", gen_int_libfunc },
  { '3', "umod", gen_int_libfunc },
  { '2', "ftrunc", gen_fp_libfunc },
  { '3', "and", gen_int_libfunc },
  { '3', "ior", gen_int_libfunc },
  { '3', "xor", gen_int_libfunc },
  { '3', "ashl", gen_int_fixed_libfunc },
  { '3', "ssashl", gen_signed_fixed_libfunc },
  { '3', "usashl", gen_unsigned_fixed_libfunc },
  { '3', "ashr", gen_int_signed_fixed_libfunc },
  { '3', "lshr", gen_int_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '3', "min", gen_int_fp_libfunc },
  { '3', "max", gen_int_fp_libfunc },
  { '3', "umin", gen_int_libfunc },
  { '3', "umax", gen_int_libfunc },
  { '2', "neg", gen_int_fp_fixed_libfunc },
  { '2', "neg", gen_intv_fp_libfunc },
  { '2', "ssneg", gen_signed_fixed_libfunc },
  { '2', "usneg", gen_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '2', "one_cmpl", gen_int_libfunc },
  { '\0', NULL, NULL },
  { '2', "ffs", gen_int_libfunc },
  { '2', "clz", gen_int_libfunc },
  { '2', "ctz", gen_int_libfunc },
  { '2', "clrsb", gen_int_libfunc },
  { '2', "popcount", gen_int_libfunc },
  { '2', "parity", gen_int_libfunc },
  { '2', "cmp", gen_int_fp_fixed_libfunc },
  { '2', "ucmp", gen_int_libfunc },
  { '2', "eq", gen_fp_libfunc },
  { '2', "ne", gen_fp_libfunc },
  { '2', "gt", gen_fp_libfunc },
  { '2', "ge", gen_fp_libfunc },
  { '2', "lt", gen_fp_libfunc },
  { '2', "le", gen_fp_libfunc },
  { '2', "unord", gen_fp_libfunc },
  { '2', "powi", gen_fp_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
};

enum rtx_code const optab_to_code_[NUM_OPTABS] = {
  UNKNOWN,
  SIGN_EXTEND,
  TRUNCATE,
  ZERO_EXTEND,
  FIX,
  UNSIGNED_FIX,
  FLOAT,
  UNSIGNED_FLOAT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  FRACT_CONVERT,
  UNSIGNED_FRACT_CONVERT,
  SAT_FRACT,
  UNSIGNED_SAT_FRACT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  PLUS,
  PLUS,
  SS_PLUS,
  US_PLUS,
  MINUS,
  MINUS,
  SS_MINUS,
  US_MINUS,
  MULT,
  MULT,
  SS_MULT,
  US_MULT,
  DIV,
  DIV,
  SS_DIV,
  UDIV,
  US_DIV,
  UNKNOWN,
  UNKNOWN,
  MOD,
  UMOD,
  UNKNOWN,
  AND,
  IOR,
  XOR,
  ASHIFT,
  SS_ASHIFT,
  US_ASHIFT,
  ASHIFTRT,
  LSHIFTRT,
  ROTATE,
  ROTATERT,
  ASHIFT,
  ASHIFTRT,
  LSHIFTRT,
  ROTATE,
  ROTATERT,
  SMIN,
  SMAX,
  UMIN,
  UMAX,
  NEG,
  NEG,
  SS_NEG,
  US_NEG,
  ABS,
  ABS,
  NOT,
  BSWAP,
  FFS,
  CLZ,
  CTZ,
  CLRSB,
  POPCOUNT,
  PARITY,
  UNKNOWN,
  UNKNOWN,
  EQ,
  NE,
  GT,
  GE,
  LT,
  LE,
  UNORDERED,
  UNKNOWN,
  SQRT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  SET,
  STRICT_LOW_PART,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  COMPARE,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  FMA,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  VEC_DUPLICATE,
  VEC_SERIES,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
};

const optab code_to_optab_[NUM_RTX_CODE] = {
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  mov_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  movstrict_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  cbranch_optab,
  add_optab,
  sub_optab,
  neg_optab,
  smul_optab,
  ssmul_optab,
  usmul_optab,
  unknown_optab,
  unknown_optab,
  sdiv_optab,
  ssdiv_optab,
  usdiv_optab,
  smod_optab,
  udiv_optab,
  umod_optab,
  and_optab,
  ior_optab,
  xor_optab,
  one_cmpl_optab,
  ashl_optab,
  rotl_optab,
  ashr_optab,
  lshr_optab,
  rotr_optab,
  smin_optab,
  smax_optab,
  umin_optab,
  umax_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  ne_optab,
  eq_optab,
  ge_optab,
  gt_optab,
  le_optab,
  lt_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unord_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  abs_optab,
  sqrt_optab,
  bswap_optab,
  ffs_optab,
  clrsb_optab,
  clz_optab,
  ctz_optab,
  popcount_optab,
  parity_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  vec_duplicate_optab,
  vec_series_optab,
  ssadd_optab,
  usadd_optab,
  sssub_optab,
  ssneg_optab,
  usneg_optab,
  unknown_optab,
  ssashl_optab,
  usashl_optab,
  ussub_optab,
  unknown_optab,
  unknown_optab,
  fma_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
};

