/* Generated automatically by the program `genopinit'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "memmodel.h"
#include "tm_p.h"
#include "flags.h"
#include "insn-config.h"
#include "expmed.h"
#include "dojump.h"
#include "explow.h"
#include "emit-rtl.h"
#include "stmt.h"
#include "expr.h"
#include "insn-codes.h"
#include "optabs.h"

struct optab_pat {
  unsigned scode;
  enum insn_code icode;
};

static const struct optab_pat pats[NUM_OPTAB_PATTERNS] = {
  { 0x101406, CODE_FOR_extendqihi2 },
  { 0x101407, CODE_FOR_extendqisi2 },
  { 0x101408, CODE_FOR_extendqidi2 },
  { 0x101807, CODE_FOR_extendhisi2 },
  { 0x101808, CODE_FOR_extendhidi2 },
  { 0x101c08, CODE_FOR_extendsidi2 },
  { 0x10741e, CODE_FOR_extendsfdf2 },
  { 0x20781d, CODE_FOR_truncdfsf2 },
  { 0x301406, CODE_FOR_zero_extendqihi2 },
  { 0x301407, CODE_FOR_zero_extendqisi2 },
  { 0x301408, CODE_FOR_zero_extendqidi2 },
  { 0x301807, CODE_FOR_zero_extendhisi2 },
  { 0x301808, CODE_FOR_zero_extendhidi2 },
  { 0x301c08, CODE_FOR_zero_extendsidi2 },
  { 0x601c1d, CODE_FOR_floatsisf2 },
  { 0x601c1e, CODE_FOR_floatsidf2 },
  { 0x60201d, CODE_FOR_floatdisf2 },
  { 0x60201e, CODE_FOR_floatdidf2 },
  { 0x60cc45, CODE_FOR_floatv4siv4sf2 },
  { 0x60d046, CODE_FOR_floatv2div2df2 },
  { 0x60dc47, CODE_FOR_floatv8siv8sf2 },
  { 0x60e048, CODE_FOR_floatv4div4df2 },
  { 0x70cc45, CODE_FOR_floatunsv4siv4sf2 },
  { 0x70d046, CODE_FOR_floatunsv2div2df2 },
  { 0x70dc47, CODE_FOR_floatunsv8siv8sf2 },
  { 0x70e048, CODE_FOR_floatunsv4div4df2 },
  { 0x807407, CODE_FOR_lrintsfsi2 },
  { 0x807408, CODE_FOR_lrintsfdi2 },
  { 0x807807, CODE_FOR_lrintdfsi2 },
  { 0x807808, CODE_FOR_lrintdfdi2 },
  { 0x811433, CODE_FOR_lrintv4sfv4si2 },
  { 0x811834, CODE_FOR_lrintv2dfv2di2 },
  { 0x811c37, CODE_FOR_lrintv8sfv8si2 },
  { 0x812038, CODE_FOR_lrintv4dfv4di2 },
  { 0xa07407, CODE_FOR_lfloorsfsi2 },
  { 0xa07408, CODE_FOR_lfloorsfdi2 },
  { 0xa07807, CODE_FOR_lfloordfsi2 },
  { 0xa07808, CODE_FOR_lfloordfdi2 },
  { 0xa11433, CODE_FOR_lfloorv4sfv4si2 },
  { 0xa11834, CODE_FOR_lfloorv2dfv2di2 },
  { 0xa11c37, CODE_FOR_lfloorv8sfv8si2 },
  { 0xa12038, CODE_FOR_lfloorv4dfv4di2 },
  { 0xb07407, CODE_FOR_lceilsfsi2 },
  { 0xb07408, CODE_FOR_lceilsfdi2 },
  { 0xb07807, CODE_FOR_lceildfsi2 },
  { 0xb07808, CODE_FOR_lceildfdi2 },
  { 0xb11433, CODE_FOR_lceilv4sfv4si2 },
  { 0xb11834, CODE_FOR_lceilv2dfv2di2 },
  { 0xb11c37, CODE_FOR_lceilv8sfv8si2 },
  { 0xb12038, CODE_FOR_lceilv4dfv4di2 },
  { 0x1007407, CODE_FOR_fix_truncsfsi2 },
  { 0x1007408, CODE_FOR_fix_truncsfdi2 },
  { 0x1007807, CODE_FOR_fix_truncdfsi2 },
  { 0x1007808, CODE_FOR_fix_truncdfdi2 },
  { 0x1011433, CODE_FOR_fix_truncv4sfv4si2 },
  { 0x1011834, CODE_FOR_fix_truncv2dfv2di2 },
  { 0x1011c37, CODE_FOR_fix_truncv8sfv8si2 },
  { 0x1012038, CODE_FOR_fix_truncv4dfv4di2 },
  { 0x1107407, CODE_FOR_fixuns_truncsfsi2 },
  { 0x1107408, CODE_FOR_fixuns_truncsfdi2 },
  { 0x1107807, CODE_FOR_fixuns_truncdfsi2 },
  { 0x1107808, CODE_FOR_fixuns_truncdfdi2 },
  { 0x1111433, CODE_FOR_fixuns_truncv4sfv4si2 },
  { 0x1111834, CODE_FOR_fixuns_truncv2dfv2di2 },
  { 0x1111c37, CODE_FOR_fixuns_truncv8sfv8si2 },
  { 0x1112038, CODE_FOR_fixuns_truncv4dfv4di2 },
  { 0x1201c08, CODE_FOR_mulsidi3 },
  { 0x1202009, CODE_FOR_mulditi3 },
  { 0x1301c08, CODE_FOR_umulsidi3 },
  { 0x1302009, CODE_FOR_umulditi3 },
  { 0x230c431, CODE_FOR_vcondv16qiv16qi },
  { 0x230c432, CODE_FOR_vcondv8hiv16qi },
  { 0x230c433, CODE_FOR_vcondv4siv16qi },
  { 0x230c434, CODE_FOR_vcondv2div16qi },
  { 0x230c445, CODE_FOR_vcondv4sfv16qi },
  { 0x230c446, CODE_FOR_vcondv2dfv16qi },
  { 0x230c831, CODE_FOR_vcondv16qiv8hi },
  { 0x230c832, CODE_FOR_vcondv8hiv8hi },
  { 0x230c833, CODE_FOR_vcondv4siv8hi },
  { 0x230c834, CODE_FOR_vcondv2div8hi },
  { 0x230c845, CODE_FOR_vcondv4sfv8hi },
  { 0x230c846, CODE_FOR_vcondv2dfv8hi },
  { 0x230cc31, CODE_FOR_vcondv16qiv4si },
  { 0x230cc32, CODE_FOR_vcondv8hiv4si },
  { 0x230cc33, CODE_FOR_vcondv4siv4si },
  { 0x230cc34, CODE_FOR_vcondv2div4si },
  { 0x230cc45, CODE_FOR_vcondv4sfv4si },
  { 0x230cc46, CODE_FOR_vcondv2dfv4si },
  { 0x230d031, CODE_FOR_vcondv16qiv2di },
  { 0x230d032, CODE_FOR_vcondv8hiv2di },
  { 0x230d033, CODE_FOR_vcondv4siv2di },
  { 0x230d034, CODE_FOR_vcondv2div2di },
  { 0x230d045, CODE_FOR_vcondv4sfv2di },
  { 0x230d046, CODE_FOR_vcondv2dfv2di },
  { 0x230d435, CODE_FOR_vcondv32qiv32qi },
  { 0x230d436, CODE_FOR_vcondv16hiv32qi },
  { 0x230d437, CODE_FOR_vcondv8siv32qi },
  { 0x230d438, CODE_FOR_vcondv4div32qi },
  { 0x230d447, CODE_FOR_vcondv8sfv32qi },
  { 0x230d448, CODE_FOR_vcondv4dfv32qi },
  { 0x230d835, CODE_FOR_vcondv32qiv16hi },
  { 0x230d836, CODE_FOR_vcondv16hiv16hi },
  { 0x230d837, CODE_FOR_vcondv8siv16hi },
  { 0x230d838, CODE_FOR_vcondv4div16hi },
  { 0x230d847, CODE_FOR_vcondv8sfv16hi },
  { 0x230d848, CODE_FOR_vcondv4dfv16hi },
  { 0x230dc35, CODE_FOR_vcondv32qiv8si },
  { 0x230dc36, CODE_FOR_vcondv16hiv8si },
  { 0x230dc37, CODE_FOR_vcondv8siv8si },
  { 0x230dc38, CODE_FOR_vcondv4div8si },
  { 0x230dc47, CODE_FOR_vcondv8sfv8si },
  { 0x230dc48, CODE_FOR_vcondv4dfv8si },
  { 0x230e035, CODE_FOR_vcondv32qiv4di },
  { 0x230e036, CODE_FOR_vcondv16hiv4di },
  { 0x230e037, CODE_FOR_vcondv8siv4di },
  { 0x230e038, CODE_FOR_vcondv4div4di },
  { 0x230e047, CODE_FOR_vcondv8sfv4di },
  { 0x230e048, CODE_FOR_vcondv4dfv4di },
  { 0x2311431, CODE_FOR_vcondv16qiv4sf },
  { 0x2311432, CODE_FOR_vcondv8hiv4sf },
  { 0x2311433, CODE_FOR_vcondv4siv4sf },
  { 0x2311434, CODE_FOR_vcondv2div4sf },
  { 0x2311445, CODE_FOR_vcondv4sfv4sf },
  { 0x2311446, CODE_FOR_vcondv2dfv4sf },
  { 0x2311831, CODE_FOR_vcondv16qiv2df },
  { 0x2311832, CODE_FOR_vcondv8hiv2df },
  { 0x2311833, CODE_FOR_vcondv4siv2df },
  { 0x2311834, CODE_FOR_vcondv2div2df },
  { 0x2311845, CODE_FOR_vcondv4sfv2df },
  { 0x2311846, CODE_FOR_vcondv2dfv2df },
  { 0x2311c35, CODE_FOR_vcondv32qiv8sf },
  { 0x2311c36, CODE_FOR_vcondv16hiv8sf },
  { 0x2311c37, CODE_FOR_vcondv8siv8sf },
  { 0x2311c38, CODE_FOR_vcondv4div8sf },
  { 0x2311c47, CODE_FOR_vcondv8sfv8sf },
  { 0x2311c48, CODE_FOR_vcondv4dfv8sf },
  { 0x2312035, CODE_FOR_vcondv32qiv4df },
  { 0x2312036, CODE_FOR_vcondv16hiv4df },
  { 0x2312037, CODE_FOR_vcondv8siv4df },
  { 0x2312038, CODE_FOR_vcondv4div4df },
  { 0x2312047, CODE_FOR_vcondv8sfv4df },
  { 0x2312048, CODE_FOR_vcondv4dfv4df },
  { 0x240c431, CODE_FOR_vconduv16qiv16qi },
  { 0x240c432, CODE_FOR_vconduv8hiv16qi },
  { 0x240c433, CODE_FOR_vconduv4siv16qi },
  { 0x240c434, CODE_FOR_vconduv2div16qi },
  { 0x240c445, CODE_FOR_vconduv4sfv16qi },
  { 0x240c446, CODE_FOR_vconduv2dfv16qi },
  { 0x240c831, CODE_FOR_vconduv16qiv8hi },
  { 0x240c832, CODE_FOR_vconduv8hiv8hi },
  { 0x240c833, CODE_FOR_vconduv4siv8hi },
  { 0x240c834, CODE_FOR_vconduv2div8hi },
  { 0x240c845, CODE_FOR_vconduv4sfv8hi },
  { 0x240c846, CODE_FOR_vconduv2dfv8hi },
  { 0x240cc31, CODE_FOR_vconduv16qiv4si },
  { 0x240cc32, CODE_FOR_vconduv8hiv4si },
  { 0x240cc33, CODE_FOR_vconduv4siv4si },
  { 0x240cc34, CODE_FOR_vconduv2div4si },
  { 0x240cc45, CODE_FOR_vconduv4sfv4si },
  { 0x240cc46, CODE_FOR_vconduv2dfv4si },
  { 0x240d031, CODE_FOR_vconduv16qiv2di },
  { 0x240d032, CODE_FOR_vconduv8hiv2di },
  { 0x240d033, CODE_FOR_vconduv4siv2di },
  { 0x240d034, CODE_FOR_vconduv2div2di },
  { 0x240d045, CODE_FOR_vconduv4sfv2di },
  { 0x240d046, CODE_FOR_vconduv2dfv2di },
  { 0x240d435, CODE_FOR_vconduv32qiv32qi },
  { 0x240d436, CODE_FOR_vconduv16hiv32qi },
  { 0x240d437, CODE_FOR_vconduv8siv32qi },
  { 0x240d438, CODE_FOR_vconduv4div32qi },
  { 0x240d447, CODE_FOR_vconduv8sfv32qi },
  { 0x240d448, CODE_FOR_vconduv4dfv32qi },
  { 0x240d835, CODE_FOR_vconduv32qiv16hi },
  { 0x240d836, CODE_FOR_vconduv16hiv16hi },
  { 0x240d837, CODE_FOR_vconduv8siv16hi },
  { 0x240d838, CODE_FOR_vconduv4div16hi },
  { 0x240d847, CODE_FOR_vconduv8sfv16hi },
  { 0x240d848, CODE_FOR_vconduv4dfv16hi },
  { 0x240dc35, CODE_FOR_vconduv32qiv8si },
  { 0x240dc36, CODE_FOR_vconduv16hiv8si },
  { 0x240dc37, CODE_FOR_vconduv8siv8si },
  { 0x240dc38, CODE_FOR_vconduv4div8si },
  { 0x240dc47, CODE_FOR_vconduv8sfv8si },
  { 0x240dc48, CODE_FOR_vconduv4dfv8si },
  { 0x240e035, CODE_FOR_vconduv32qiv4di },
  { 0x240e036, CODE_FOR_vconduv16hiv4di },
  { 0x240e037, CODE_FOR_vconduv8siv4di },
  { 0x240e038, CODE_FOR_vconduv4div4di },
  { 0x240e047, CODE_FOR_vconduv8sfv4di },
  { 0x240e048, CODE_FOR_vconduv4dfv4di },
  { 0x260c431, CODE_FOR_vcond_mask_v16qiv16qi },
  { 0x260c832, CODE_FOR_vcond_mask_v8hiv8hi },
  { 0x260cc33, CODE_FOR_vcond_mask_v4siv4si },
  { 0x260cc45, CODE_FOR_vcond_mask_v4sfv4si },
  { 0x260d034, CODE_FOR_vcond_mask_v2div2di },
  { 0x260d046, CODE_FOR_vcond_mask_v2dfv2di },
  { 0x260d435, CODE_FOR_vcond_mask_v32qiv32qi },
  { 0x260d836, CODE_FOR_vcond_mask_v16hiv16hi },
  { 0x260dc37, CODE_FOR_vcond_mask_v8siv8si },
  { 0x260dc47, CODE_FOR_vcond_mask_v8sfv8si },
  { 0x260e038, CODE_FOR_vcond_mask_v4div4di },
  { 0x260e048, CODE_FOR_vcond_mask_v4dfv4di },
  { 0x270c431, CODE_FOR_vec_cmpv16qiv16qi },
  { 0x270c832, CODE_FOR_vec_cmpv8hiv8hi },
  { 0x270cc33, CODE_FOR_vec_cmpv4siv4si },
  { 0x270cc45, CODE_FOR_vec_cmpv4sfv4si },
  { 0x270d034, CODE_FOR_vec_cmpv2div2di },
  { 0x270d046, CODE_FOR_vec_cmpv2dfv2di },
  { 0x270d435, CODE_FOR_vec_cmpv32qiv32qi },
  { 0x270d836, CODE_FOR_vec_cmpv16hiv16hi },
  { 0x270dc37, CODE_FOR_vec_cmpv8siv8si },
  { 0x270dc47, CODE_FOR_vec_cmpv8sfv8si },
  { 0x270e038, CODE_FOR_vec_cmpv4div4di },
  { 0x270e048, CODE_FOR_vec_cmpv4dfv4di },
  { 0x280c431, CODE_FOR_vec_cmpuv16qiv16qi },
  { 0x280c832, CODE_FOR_vec_cmpuv8hiv8hi },
  { 0x280cc33, CODE_FOR_vec_cmpuv4siv4si },
  { 0x280d034, CODE_FOR_vec_cmpuv2div2di },
  { 0x280d435, CODE_FOR_vec_cmpuv32qiv32qi },
  { 0x280d836, CODE_FOR_vec_cmpuv16hiv16hi },
  { 0x280dc37, CODE_FOR_vec_cmpuv8siv8si },
  { 0x280e038, CODE_FOR_vec_cmpuv4div4di },
  { 0x3401431, CODE_FOR_vec_extractv16qiqi },
  { 0x3401435, CODE_FOR_vec_extractv32qiqi },
  { 0x3401832, CODE_FOR_vec_extractv8hihi },
  { 0x3401836, CODE_FOR_vec_extractv16hihi },
  { 0x3401c33, CODE_FOR_vec_extractv4sisi },
  { 0x3401c37, CODE_FOR_vec_extractv8sisi },
  { 0x3402034, CODE_FOR_vec_extractv2didi },
  { 0x3402038, CODE_FOR_vec_extractv4didi },
  { 0x3407445, CODE_FOR_vec_extractv4sfsf },
  { 0x3407447, CODE_FOR_vec_extractv8sfsf },
  { 0x3407846, CODE_FOR_vec_extractv2dfdf },
  { 0x3407848, CODE_FOR_vec_extractv4dfdf },
  { 0x3501431, CODE_FOR_vec_initv16qiqi },
  { 0x3501435, CODE_FOR_vec_initv32qiqi },
  { 0x3501832, CODE_FOR_vec_initv8hihi },
  { 0x3501836, CODE_FOR_vec_initv16hihi },
  { 0x3501c33, CODE_FOR_vec_initv4sisi },
  { 0x3501c37, CODE_FOR_vec_initv8sisi },
  { 0x3502034, CODE_FOR_vec_initv2didi },
  { 0x3502038, CODE_FOR_vec_initv4didi },
  { 0x3507445, CODE_FOR_vec_initv4sfsf },
  { 0x3507447, CODE_FOR_vec_initv8sfsf },
  { 0x3507846, CODE_FOR_vec_initv2dfdf },
  { 0x3507848, CODE_FOR_vec_initv4dfdf },
  { 0x350c435, CODE_FOR_vec_initv32qiv16qi },
  { 0x350c836, CODE_FOR_vec_initv16hiv8hi },
  { 0x350cc37, CODE_FOR_vec_initv8siv4si },
  { 0x350d038, CODE_FOR_vec_initv4div2di },
  { 0x3511447, CODE_FOR_vec_initv8sfv4sf },
  { 0x3511848, CODE_FOR_vec_initv4dfv2df },
  { 0x3700007, CODE_FOR_addsi3 },
  { 0x3700008, CODE_FOR_adddi3 },
  { 0x370001d, CODE_FOR_addsf3 },
  { 0x370001e, CODE_FOR_adddf3 },
  { 0x3700031, CODE_FOR_addv16qi3 },
  { 0x3700032, CODE_FOR_addv8hi3 },
  { 0x3700033, CODE_FOR_addv4si3 },
  { 0x3700034, CODE_FOR_addv2di3 },
  { 0x3700035, CODE_FOR_addv32qi3 },
  { 0x3700036, CODE_FOR_addv16hi3 },
  { 0x3700037, CODE_FOR_addv8si3 },
  { 0x3700038, CODE_FOR_addv4di3 },
  { 0x3700045, CODE_FOR_addv4sf3 },
  { 0x3700046, CODE_FOR_addv2df3 },
  { 0x3700047, CODE_FOR_addv8sf3 },
  { 0x3700048, CODE_FOR_addv4df3 },
  { 0x3b00007, CODE_FOR_subsi3 },
  { 0x3b00008, CODE_FOR_subdi3 },
  { 0x3b0001d, CODE_FOR_subsf3 },
  { 0x3b0001e, CODE_FOR_subdf3 },
  { 0x3b00031, CODE_FOR_subv16qi3 },
  { 0x3b00032, CODE_FOR_subv8hi3 },
  { 0x3b00033, CODE_FOR_subv4si3 },
  { 0x3b00034, CODE_FOR_subv2di3 },
  { 0x3b00035, CODE_FOR_subv32qi3 },
  { 0x3b00036, CODE_FOR_subv16hi3 },
  { 0x3b00037, CODE_FOR_subv8si3 },
  { 0x3b00038, CODE_FOR_subv4di3 },
  { 0x3b00045, CODE_FOR_subv4sf3 },
  { 0x3b00046, CODE_FOR_subv2df3 },
  { 0x3b00047, CODE_FOR_subv8sf3 },
  { 0x3b00048, CODE_FOR_subv4df3 },
  { 0x3f00007, CODE_FOR_mulsi3 },
  { 0x3f00008, CODE_FOR_muldi3 },
  { 0x3f0001d, CODE_FOR_mulsf3 },
  { 0x3f0001e, CODE_FOR_muldf3 },
  { 0x3f00031, CODE_FOR_mulv16qi3 },
  { 0x3f00032, CODE_FOR_mulv8hi3 },
  { 0x3f00033, CODE_FOR_mulv4si3 },
  { 0x3f00034, CODE_FOR_mulv2di3 },
  { 0x3f00035, CODE_FOR_mulv32qi3 },
  { 0x3f00036, CODE_FOR_mulv16hi3 },
  { 0x3f00037, CODE_FOR_mulv8si3 },
  { 0x3f00038, CODE_FOR_mulv4di3 },
  { 0x3f00045, CODE_FOR_mulv4sf3 },
  { 0x3f00046, CODE_FOR_mulv2df3 },
  { 0x3f00047, CODE_FOR_mulv8sf3 },
  { 0x3f00048, CODE_FOR_mulv4df3 },
  { 0x4300007, CODE_FOR_divsi3 },
  { 0x4300008, CODE_FOR_divdi3 },
  { 0x430001d, CODE_FOR_divsf3 },
  { 0x430001e, CODE_FOR_divdf3 },
  { 0x4300031, CODE_FOR_divv16qi3 },
  { 0x4300032, CODE_FOR_divv8hi3 },
  { 0x4300033, CODE_FOR_divv4si3 },
  { 0x4300034, CODE_FOR_divv2di3 },
  { 0x4300035, CODE_FOR_divv32qi3 },
  { 0x4300036, CODE_FOR_divv16hi3 },
  { 0x4300037, CODE_FOR_divv8si3 },
  { 0x4300038, CODE_FOR_divv4di3 },
  { 0x4300045, CODE_FOR_divv4sf3 },
  { 0x4300046, CODE_FOR_divv2df3 },
  { 0x4300047, CODE_FOR_divv8sf3 },
  { 0x4300048, CODE_FOR_divv4df3 },
  { 0x4600007, CODE_FOR_udivsi3 },
  { 0x4600008, CODE_FOR_udivdi3 },
  { 0x4600031, CODE_FOR_udivv16qi3 },
  { 0x4600032, CODE_FOR_udivv8hi3 },
  { 0x4600033, CODE_FOR_udivv4si3 },
  { 0x4600034, CODE_FOR_udivv2di3 },
  { 0x4600035, CODE_FOR_udivv32qi3 },
  { 0x4600036, CODE_FOR_udivv16hi3 },
  { 0x4600037, CODE_FOR_udivv8si3 },
  { 0x4600038, CODE_FOR_udivv4di3 },
  { 0x4a00007, CODE_FOR_modsi3 },
  { 0x4a00008, CODE_FOR_moddi3 },
  { 0x4a00031, CODE_FOR_modv16qi3 },
  { 0x4a00032, CODE_FOR_modv8hi3 },
  { 0x4a00033, CODE_FOR_modv4si3 },
  { 0x4a00034, CODE_FOR_modv2di3 },
  { 0x4a00035, CODE_FOR_modv32qi3 },
  { 0x4a00036, CODE_FOR_modv16hi3 },
  { 0x4a00037, CODE_FOR_modv8si3 },
  { 0x4a00038, CODE_FOR_modv4di3 },
  { 0x4b00007, CODE_FOR_umodsi3 },
  { 0x4b00008, CODE_FOR_umoddi3 },
  { 0x4b00031, CODE_FOR_umodv16qi3 },
  { 0x4b00032, CODE_FOR_umodv8hi3 },
  { 0x4b00033, CODE_FOR_umodv4si3 },
  { 0x4b00034, CODE_FOR_umodv2di3 },
  { 0x4b00035, CODE_FOR_umodv32qi3 },
  { 0x4b00036, CODE_FOR_umodv16hi3 },
  { 0x4b00037, CODE_FOR_umodv8si3 },
  { 0x4b00038, CODE_FOR_umodv4di3 },
  { 0x4c00045, CODE_FOR_ftruncv4sf2 },
  { 0x4c00046, CODE_FOR_ftruncv2df2 },
  { 0x4c00047, CODE_FOR_ftruncv8sf2 },
  { 0x4c00048, CODE_FOR_ftruncv4df2 },
  { 0x4d00007, CODE_FOR_andsi3 },
  { 0x4d00008, CODE_FOR_anddi3 },
  { 0x4d00031, CODE_FOR_andv16qi3 },
  { 0x4d00032, CODE_FOR_andv8hi3 },
  { 0x4d00033, CODE_FOR_andv4si3 },
  { 0x4d00034, CODE_FOR_andv2di3 },
  { 0x4d00035, CODE_FOR_andv32qi3 },
  { 0x4d00036, CODE_FOR_andv16hi3 },
  { 0x4d00037, CODE_FOR_andv8si3 },
  { 0x4d00038, CODE_FOR_andv4di3 },
  { 0x4d00045, CODE_FOR_andv4sf3 },
  { 0x4d00046, CODE_FOR_andv2df3 },
  { 0x4d00047, CODE_FOR_andv8sf3 },
  { 0x4d00048, CODE_FOR_andv4df3 },
  { 0x4e00007, CODE_FOR_iorsi3 },
  { 0x4e00008, CODE_FOR_iordi3 },
  { 0x4e00031, CODE_FOR_iorv16qi3 },
  { 0x4e00032, CODE_FOR_iorv8hi3 },
  { 0x4e00033, CODE_FOR_iorv4si3 },
  { 0x4e00034, CODE_FOR_iorv2di3 },
  { 0x4e00035, CODE_FOR_iorv32qi3 },
  { 0x4e00036, CODE_FOR_iorv16hi3 },
  { 0x4e00037, CODE_FOR_iorv8si3 },
  { 0x4e00038, CODE_FOR_iorv4di3 },
  { 0x4e00045, CODE_FOR_iorv4sf3 },
  { 0x4e00046, CODE_FOR_iorv2df3 },
  { 0x4e00047, CODE_FOR_iorv8sf3 },
  { 0x4e00048, CODE_FOR_iorv4df3 },
  { 0x4f00007, CODE_FOR_xorsi3 },
  { 0x4f00008, CODE_FOR_xordi3 },
  { 0x4f00031, CODE_FOR_xorv16qi3 },
  { 0x4f00032, CODE_FOR_xorv8hi3 },
  { 0x4f00033, CODE_FOR_xorv4si3 },
  { 0x4f00034, CODE_FOR_xorv2di3 },
  { 0x4f00035, CODE_FOR_xorv32qi3 },
  { 0x4f00036, CODE_FOR_xorv16hi3 },
  { 0x4f00037, CODE_FOR_xorv8si3 },
  { 0x4f00038, CODE_FOR_xorv4di3 },
  { 0x4f00045, CODE_FOR_xorv4sf3 },
  { 0x4f00046, CODE_FOR_xorv2df3 },
  { 0x4f00047, CODE_FOR_xorv8sf3 },
  { 0x4f00048, CODE_FOR_xorv4df3 },
  { 0x5000007, CODE_FOR_ashlsi3 },
  { 0x5000008, CODE_FOR_ashldi3 },
  { 0x5300007, CODE_FOR_ashrsi3 },
  { 0x5300008, CODE_FOR_ashrdi3 },
  { 0x5400007, CODE_FOR_lshrsi3 },
  { 0x5400008, CODE_FOR_lshrdi3 },
  { 0x5500007, CODE_FOR_rotlsi3 },
  { 0x5500008, CODE_FOR_rotldi3 },
  { 0x5500031, CODE_FOR_rotlv16qi3 },
  { 0x5500032, CODE_FOR_rotlv8hi3 },
  { 0x5500033, CODE_FOR_rotlv4si3 },
  { 0x5500034, CODE_FOR_rotlv2di3 },
  { 0x5500035, CODE_FOR_rotlv32qi3 },
  { 0x5500036, CODE_FOR_rotlv16hi3 },
  { 0x5500037, CODE_FOR_rotlv8si3 },
  { 0x5500038, CODE_FOR_rotlv4di3 },
  { 0x5600007, CODE_FOR_rotrsi3 },
  { 0x5600008, CODE_FOR_rotrdi3 },
  { 0x5600031, CODE_FOR_rotrv16qi3 },
  { 0x5600032, CODE_FOR_rotrv8hi3 },
  { 0x5600033, CODE_FOR_rotrv4si3 },
  { 0x5600034, CODE_FOR_rotrv2di3 },
  { 0x5600035, CODE_FOR_rotrv32qi3 },
  { 0x5600036, CODE_FOR_rotrv16hi3 },
  { 0x5600037, CODE_FOR_rotrv8si3 },
  { 0x5600038, CODE_FOR_rotrv4di3 },
  { 0x5700031, CODE_FOR_vashlv16qi3 },
  { 0x5700032, CODE_FOR_vashlv8hi3 },
  { 0x5700033, CODE_FOR_vashlv4si3 },
  { 0x5700034, CODE_FOR_vashlv2di3 },
  { 0x5700035, CODE_FOR_vashlv32qi3 },
  { 0x5700036, CODE_FOR_vashlv16hi3 },
  { 0x5700037, CODE_FOR_vashlv8si3 },
  { 0x5700038, CODE_FOR_vashlv4di3 },
  { 0x5800031, CODE_FOR_vashrv16qi3 },
  { 0x5800032, CODE_FOR_vashrv8hi3 },
  { 0x5800033, CODE_FOR_vashrv4si3 },
  { 0x5800034, CODE_FOR_vashrv2di3 },
  { 0x5800035, CODE_FOR_vashrv32qi3 },
  { 0x5800036, CODE_FOR_vashrv16hi3 },
  { 0x5800037, CODE_FOR_vashrv8si3 },
  { 0x5800038, CODE_FOR_vashrv4di3 },
  { 0x5900031, CODE_FOR_vlshrv16qi3 },
  { 0x5900032, CODE_FOR_vlshrv8hi3 },
  { 0x5900033, CODE_FOR_vlshrv4si3 },
  { 0x5900034, CODE_FOR_vlshrv2di3 },
  { 0x5900035, CODE_FOR_vlshrv32qi3 },
  { 0x5900036, CODE_FOR_vlshrv16hi3 },
  { 0x5900037, CODE_FOR_vlshrv8si3 },
  { 0x5900038, CODE_FOR_vlshrv4di3 },
  { 0x5a00031, CODE_FOR_vrotlv16qi3 },
  { 0x5a00032, CODE_FOR_vrotlv8hi3 },
  { 0x5a00033, CODE_FOR_vrotlv4si3 },
  { 0x5a00034, CODE_FOR_vrotlv2di3 },
  { 0x5a00035, CODE_FOR_vrotlv32qi3 },
  { 0x5a00036, CODE_FOR_vrotlv16hi3 },
  { 0x5a00037, CODE_FOR_vrotlv8si3 },
  { 0x5a00038, CODE_FOR_vrotlv4di3 },
  { 0x5b00031, CODE_FOR_vrotrv16qi3 },
  { 0x5b00032, CODE_FOR_vrotrv8hi3 },
  { 0x5b00033, CODE_FOR_vrotrv4si3 },
  { 0x5b00034, CODE_FOR_vrotrv2di3 },
  { 0x5b00035, CODE_FOR_vrotrv32qi3 },
  { 0x5b00036, CODE_FOR_vrotrv16hi3 },
  { 0x5b00037, CODE_FOR_vrotrv8si3 },
  { 0x5b00038, CODE_FOR_vrotrv4di3 },
  { 0x5c0001d, CODE_FOR_sminsf3 },
  { 0x5c0001e, CODE_FOR_smindf3 },
  { 0x5c00031, CODE_FOR_sminv16qi3 },
  { 0x5c00032, CODE_FOR_sminv8hi3 },
  { 0x5c00033, CODE_FOR_sminv4si3 },
  { 0x5c00034, CODE_FOR_sminv2di3 },
  { 0x5c00035, CODE_FOR_sminv32qi3 },
  { 0x5c00036, CODE_FOR_sminv16hi3 },
  { 0x5c00037, CODE_FOR_sminv8si3 },
  { 0x5c00038, CODE_FOR_sminv4di3 },
  { 0x5c00045, CODE_FOR_sminv4sf3 },
  { 0x5c00046, CODE_FOR_sminv2df3 },
  { 0x5c00047, CODE_FOR_sminv8sf3 },
  { 0x5c00048, CODE_FOR_sminv4df3 },
  { 0x5d0001d, CODE_FOR_smaxsf3 },
  { 0x5d0001e, CODE_FOR_smaxdf3 },
  { 0x5d00031, CODE_FOR_smaxv16qi3 },
  { 0x5d00032, CODE_FOR_smaxv8hi3 },
  { 0x5d00033, CODE_FOR_smaxv4si3 },
  { 0x5d00034, CODE_FOR_smaxv2di3 },
  { 0x5d00035, CODE_FOR_smaxv32qi3 },
  { 0x5d00036, CODE_FOR_smaxv16hi3 },
  { 0x5d00037, CODE_FOR_smaxv8si3 },
  { 0x5d00038, CODE_FOR_smaxv4di3 },
  { 0x5d00045, CODE_FOR_smaxv4sf3 },
  { 0x5d00046, CODE_FOR_smaxv2df3 },
  { 0x5d00047, CODE_FOR_smaxv8sf3 },
  { 0x5d00048, CODE_FOR_smaxv4df3 },
  { 0x5e00031, CODE_FOR_uminv16qi3 },
  { 0x5e00032, CODE_FOR_uminv8hi3 },
  { 0x5e00033, CODE_FOR_uminv4si3 },
  { 0x5e00034, CODE_FOR_uminv2di3 },
  { 0x5e00035, CODE_FOR_uminv32qi3 },
  { 0x5e00036, CODE_FOR_uminv16hi3 },
  { 0x5e00037, CODE_FOR_uminv8si3 },
  { 0x5e00038, CODE_FOR_uminv4di3 },
  { 0x5f00031, CODE_FOR_umaxv16qi3 },
  { 0x5f00032, CODE_FOR_umaxv8hi3 },
  { 0x5f00033, CODE_FOR_umaxv4si3 },
  { 0x5f00034, CODE_FOR_umaxv2di3 },
  { 0x5f00035, CODE_FOR_umaxv32qi3 },
  { 0x5f00036, CODE_FOR_umaxv16hi3 },
  { 0x5f00037, CODE_FOR_umaxv8si3 },
  { 0x5f00038, CODE_FOR_umaxv4di3 },
  { 0x6000007, CODE_FOR_negsi2 },
  { 0x6000008, CODE_FOR_negdi2 },
  { 0x600001d, CODE_FOR_negsf2 },
  { 0x600001e, CODE_FOR_negdf2 },
  { 0x6000031, CODE_FOR_negv16qi2 },
  { 0x6000032, CODE_FOR_negv8hi2 },
  { 0x6000033, CODE_FOR_negv4si2 },
  { 0x6000034, CODE_FOR_negv2di2 },
  { 0x6000035, CODE_FOR_negv32qi2 },
  { 0x6000036, CODE_FOR_negv16hi2 },
  { 0x6000037, CODE_FOR_negv8si2 },
  { 0x6000038, CODE_FOR_negv4di2 },
  { 0x6000045, CODE_FOR_negv4sf2 },
  { 0x6000046, CODE_FOR_negv2df2 },
  { 0x6000047, CODE_FOR_negv8sf2 },
  { 0x6000048, CODE_FOR_negv4df2 },
  { 0x640001d, CODE_FOR_abssf2 },
  { 0x640001e, CODE_FOR_absdf2 },
  { 0x6400031, CODE_FOR_absv16qi2 },
  { 0x6400032, CODE_FOR_absv8hi2 },
  { 0x6400033, CODE_FOR_absv4si2 },
  { 0x6400034, CODE_FOR_absv2di2 },
  { 0x6400035, CODE_FOR_absv32qi2 },
  { 0x6400036, CODE_FOR_absv16hi2 },
  { 0x6400037, CODE_FOR_absv8si2 },
  { 0x6400038, CODE_FOR_absv4di2 },
  { 0x6400045, CODE_FOR_absv4sf2 },
  { 0x6400046, CODE_FOR_absv2df2 },
  { 0x6400047, CODE_FOR_absv8sf2 },
  { 0x6400048, CODE_FOR_absv4df2 },
  { 0x6600007, CODE_FOR_one_cmplsi2 },
  { 0x6600008, CODE_FOR_one_cmpldi2 },
  { 0x6600031, CODE_FOR_one_cmplv16qi2 },
  { 0x6600032, CODE_FOR_one_cmplv8hi2 },
  { 0x6600033, CODE_FOR_one_cmplv4si2 },
  { 0x6600034, CODE_FOR_one_cmplv2di2 },
  { 0x6600035, CODE_FOR_one_cmplv32qi2 },
  { 0x6600036, CODE_FOR_one_cmplv16hi2 },
  { 0x6600037, CODE_FOR_one_cmplv8si2 },
  { 0x6600038, CODE_FOR_one_cmplv4di2 },
  { 0x6700006, CODE_FOR_bswaphi2 },
  { 0x6700007, CODE_FOR_bswapsi2 },
  { 0x6700008, CODE_FOR_bswapdi2 },
  { 0x6900007, CODE_FOR_clzsi2 },
  { 0x6900008, CODE_FOR_clzdi2 },
  { 0x6900031, CODE_FOR_clzv16qi2 },
  { 0x6900032, CODE_FOR_clzv8hi2 },
  { 0x6900033, CODE_FOR_clzv4si2 },
  { 0x6900034, CODE_FOR_clzv2di2 },
  { 0x6900035, CODE_FOR_clzv32qi2 },
  { 0x6900036, CODE_FOR_clzv16hi2 },
  { 0x6900037, CODE_FOR_clzv8si2 },
  { 0x6900038, CODE_FOR_clzv4di2 },
  { 0x6a00007, CODE_FOR_ctzsi2 },
  { 0x6a00008, CODE_FOR_ctzdi2 },
  { 0x6c00007, CODE_FOR_popcountsi2 },
  { 0x6c00008, CODE_FOR_popcountdi2 },
  { 0x6c00031, CODE_FOR_popcountv16qi2 },
  { 0x6c00032, CODE_FOR_popcountv8hi2 },
  { 0x6c00033, CODE_FOR_popcountv4si2 },
  { 0x6c00034, CODE_FOR_popcountv2di2 },
  { 0x6c00035, CODE_FOR_popcountv32qi2 },
  { 0x6c00036, CODE_FOR_popcountv16hi2 },
  { 0x6c00037, CODE_FOR_popcountv8si2 },
  { 0x6c00038, CODE_FOR_popcountv4di2 },
  { 0x780001d, CODE_FOR_sqrtsf2 },
  { 0x780001e, CODE_FOR_sqrtdf2 },
  { 0x7800045, CODE_FOR_sqrtv4sf2 },
  { 0x7800046, CODE_FOR_sqrtv2df2 },
  { 0x7800047, CODE_FOR_sqrtv8sf2 },
  { 0x7800048, CODE_FOR_sqrtv4df2 },
  { 0x8700003, CODE_FOR_movfcc },
  { 0x8700005, CODE_FOR_movqi },
  { 0x8700006, CODE_FOR_movhi },
  { 0x8700007, CODE_FOR_movsi },
  { 0x8700008, CODE_FOR_movdi },
  { 0x870001d, CODE_FOR_movsf },
  { 0x870001e, CODE_FOR_movdf },
  { 0x8700031, CODE_FOR_movv16qi },
  { 0x8700032, CODE_FOR_movv8hi },
  { 0x8700033, CODE_FOR_movv4si },
  { 0x8700034, CODE_FOR_movv2di },
  { 0x8700035, CODE_FOR_movv32qi },
  { 0x8700036, CODE_FOR_movv16hi },
  { 0x8700037, CODE_FOR_movv8si },
  { 0x8700038, CODE_FOR_movv4di },
  { 0x8700045, CODE_FOR_movv4sf },
  { 0x8700046, CODE_FOR_movv2df },
  { 0x8700047, CODE_FOR_movv8sf },
  { 0x8700048, CODE_FOR_movv4df },
  { 0x8900031, CODE_FOR_movmisalignv16qi },
  { 0x8900032, CODE_FOR_movmisalignv8hi },
  { 0x8900033, CODE_FOR_movmisalignv4si },
  { 0x8900034, CODE_FOR_movmisalignv2di },
  { 0x8900035, CODE_FOR_movmisalignv32qi },
  { 0x8900036, CODE_FOR_movmisalignv16hi },
  { 0x8900037, CODE_FOR_movmisalignv8si },
  { 0x8900038, CODE_FOR_movmisalignv4di },
  { 0x8900045, CODE_FOR_movmisalignv4sf },
  { 0x8900046, CODE_FOR_movmisalignv2df },
  { 0x8900047, CODE_FOR_movmisalignv8sf },
  { 0x8900048, CODE_FOR_movmisalignv4df },
  { 0x8b00007, CODE_FOR_insvsi },
  { 0x8b00008, CODE_FOR_insvdi },
  { 0x8d00007, CODE_FOR_extzvsi },
  { 0x8d00008, CODE_FOR_extzvdi },
  { 0x9400005, CODE_FOR_cbranchqi4 },
  { 0x9400007, CODE_FOR_cbranchsi4 },
  { 0x9400008, CODE_FOR_cbranchdi4 },
  { 0x940001d, CODE_FOR_cbranchsf4 },
  { 0x940001e, CODE_FOR_cbranchdf4 },
  { 0x9a00007, CODE_FOR_movsicc },
  { 0x9a00008, CODE_FOR_movdicc },
  { 0x9a0001d, CODE_FOR_movsfcc },
  { 0x9a0001e, CODE_FOR_movdfcc },
  { 0xd100007, CODE_FOR_cstoresi4 },
  { 0xd100008, CODE_FOR_cstoredi4 },
  { 0xd10001d, CODE_FOR_cstoresf4 },
  { 0xd10001e, CODE_FOR_cstoredf4 },
  { 0xde00007, CODE_FOR_smulsi3_highpart },
  { 0xde00008, CODE_FOR_smuldi3_highpart },
  { 0xde00031, CODE_FOR_smulv16qi3_highpart },
  { 0xde00032, CODE_FOR_smulv8hi3_highpart },
  { 0xde00033, CODE_FOR_smulv4si3_highpart },
  { 0xde00034, CODE_FOR_smulv2di3_highpart },
  { 0xde00035, CODE_FOR_smulv32qi3_highpart },
  { 0xde00036, CODE_FOR_smulv16hi3_highpart },
  { 0xde00037, CODE_FOR_smulv8si3_highpart },
  { 0xde00038, CODE_FOR_smulv4di3_highpart },
  { 0xdf00007, CODE_FOR_umulsi3_highpart },
  { 0xdf00008, CODE_FOR_umuldi3_highpart },
  { 0xdf00031, CODE_FOR_umulv16qi3_highpart },
  { 0xdf00032, CODE_FOR_umulv8hi3_highpart },
  { 0xdf00033, CODE_FOR_umulv4si3_highpart },
  { 0xdf00034, CODE_FOR_umulv2di3_highpart },
  { 0xdf00035, CODE_FOR_umulv32qi3_highpart },
  { 0xdf00036, CODE_FOR_umulv16hi3_highpart },
  { 0xdf00037, CODE_FOR_umulv8si3_highpart },
  { 0xdf00038, CODE_FOR_umulv4di3_highpart },
  { 0xe300007, CODE_FOR_cpymemsi },
  { 0xe80001d, CODE_FOR_fmasf4 },
  { 0xe80001e, CODE_FOR_fmadf4 },
  { 0xe800045, CODE_FOR_fmav4sf4 },
  { 0xe800046, CODE_FOR_fmav2df4 },
  { 0xe800047, CODE_FOR_fmav8sf4 },
  { 0xe800048, CODE_FOR_fmav4df4 },
  { 0xe90001d, CODE_FOR_fmssf4 },
  { 0xe90001e, CODE_FOR_fmsdf4 },
  { 0xe900045, CODE_FOR_fmsv4sf4 },
  { 0xe900046, CODE_FOR_fmsv2df4 },
  { 0xe900047, CODE_FOR_fmsv8sf4 },
  { 0xe900048, CODE_FOR_fmsv4df4 },
  { 0xea0001d, CODE_FOR_fnmasf4 },
  { 0xea0001e, CODE_FOR_fnmadf4 },
  { 0xea00045, CODE_FOR_fnmav4sf4 },
  { 0xea00046, CODE_FOR_fnmav2df4 },
  { 0xea00047, CODE_FOR_fnmav8sf4 },
  { 0xea00048, CODE_FOR_fnmav4df4 },
  { 0xeb0001d, CODE_FOR_fnmssf4 },
  { 0xeb0001e, CODE_FOR_fnmsdf4 },
  { 0xec0001d, CODE_FOR_rintsf2 },
  { 0xec0001e, CODE_FOR_rintdf2 },
  { 0xec00045, CODE_FOR_rintv4sf2 },
  { 0xec00046, CODE_FOR_rintv2df2 },
  { 0xec00047, CODE_FOR_rintv8sf2 },
  { 0xec00048, CODE_FOR_rintv4df2 },
  { 0xee0001d, CODE_FOR_roundevensf2 },
  { 0xee0001e, CODE_FOR_roundevendf2 },
  { 0xee00045, CODE_FOR_roundevenv4sf2 },
  { 0xee00046, CODE_FOR_roundevenv2df2 },
  { 0xee00047, CODE_FOR_roundevenv8sf2 },
  { 0xee00048, CODE_FOR_roundevenv4df2 },
  { 0xef0001d, CODE_FOR_floorsf2 },
  { 0xef0001e, CODE_FOR_floordf2 },
  { 0xef00045, CODE_FOR_floorv4sf2 },
  { 0xef00046, CODE_FOR_floorv2df2 },
  { 0xef00047, CODE_FOR_floorv8sf2 },
  { 0xef00048, CODE_FOR_floorv4df2 },
  { 0xf00001d, CODE_FOR_ceilsf2 },
  { 0xf00001e, CODE_FOR_ceildf2 },
  { 0xf000045, CODE_FOR_ceilv4sf2 },
  { 0xf000046, CODE_FOR_ceilv2df2 },
  { 0xf000047, CODE_FOR_ceilv8sf2 },
  { 0xf000048, CODE_FOR_ceilv4df2 },
  { 0xf10001d, CODE_FOR_btruncsf2 },
  { 0xf10001e, CODE_FOR_btruncdf2 },
  { 0xf100045, CODE_FOR_btruncv4sf2 },
  { 0xf100046, CODE_FOR_btruncv2df2 },
  { 0xf100047, CODE_FOR_btruncv8sf2 },
  { 0xf100048, CODE_FOR_btruncv4df2 },
  { 0xfa0001d, CODE_FOR_copysignsf3 },
  { 0xfa0001e, CODE_FOR_copysigndf3 },
  { 0xfa00045, CODE_FOR_copysignv4sf3 },
  { 0xfa00046, CODE_FOR_copysignv2df3 },
  { 0xfa00047, CODE_FOR_copysignv8sf3 },
  { 0xfa00048, CODE_FOR_copysignv4df3 },
  { 0xfb0001d, CODE_FOR_xorsignsf3 },
  { 0xfb0001e, CODE_FOR_xorsigndf3 },
  { 0xfb00045, CODE_FOR_xorsignv4sf3 },
  { 0xfb00046, CODE_FOR_xorsignv2df3 },
  { 0xfb00047, CODE_FOR_xorsignv8sf3 },
  { 0xfb00048, CODE_FOR_xorsignv4df3 },
  { 0x10f0001d, CODE_FOR_ldexpsf3 },
  { 0x10f0001e, CODE_FOR_ldexpdf3 },
  { 0x1140001d, CODE_FOR_logbsf2 },
  { 0x1140001e, CODE_FOR_logbdf2 },
  { 0x11400045, CODE_FOR_logbv4sf2 },
  { 0x11400046, CODE_FOR_logbv2df2 },
  { 0x11400047, CODE_FOR_logbv8sf2 },
  { 0x11400048, CODE_FOR_logbv4df2 },
  { 0x1170001d, CODE_FOR_rsqrtsf2 },
  { 0x1170001e, CODE_FOR_rsqrtdf2 },
  { 0x11700045, CODE_FOR_rsqrtv4sf2 },
  { 0x11700046, CODE_FOR_rsqrtv2df2 },
  { 0x11700047, CODE_FOR_rsqrtv8sf2 },
  { 0x11700048, CODE_FOR_rsqrtv4df2 },
  { 0x1230001d, CODE_FOR_fmaxsf3 },
  { 0x1230001e, CODE_FOR_fmaxdf3 },
  { 0x12300045, CODE_FOR_fmaxv4sf3 },
  { 0x12300046, CODE_FOR_fmaxv2df3 },
  { 0x12300047, CODE_FOR_fmaxv8sf3 },
  { 0x12300048, CODE_FOR_fmaxv4df3 },
  { 0x1240001d, CODE_FOR_fminsf3 },
  { 0x1240001e, CODE_FOR_fmindf3 },
  { 0x12400045, CODE_FOR_fminv4sf3 },
  { 0x12400046, CODE_FOR_fminv2df3 },
  { 0x12400047, CODE_FOR_fminv8sf3 },
  { 0x12400048, CODE_FOR_fminv4df3 },
  { 0x12500045, CODE_FOR_reduc_fmax_scal_v4sf },
  { 0x12500046, CODE_FOR_reduc_fmax_scal_v2df },
  { 0x12500047, CODE_FOR_reduc_fmax_scal_v8sf },
  { 0x12500048, CODE_FOR_reduc_fmax_scal_v4df },
  { 0x12600045, CODE_FOR_reduc_fmin_scal_v4sf },
  { 0x12600046, CODE_FOR_reduc_fmin_scal_v2df },
  { 0x12600047, CODE_FOR_reduc_fmin_scal_v8sf },
  { 0x12600048, CODE_FOR_reduc_fmin_scal_v4df },
  { 0x12700031, CODE_FOR_reduc_smax_scal_v16qi },
  { 0x12700032, CODE_FOR_reduc_smax_scal_v8hi },
  { 0x12700033, CODE_FOR_reduc_smax_scal_v4si },
  { 0x12700034, CODE_FOR_reduc_smax_scal_v2di },
  { 0x12700035, CODE_FOR_reduc_smax_scal_v32qi },
  { 0x12700036, CODE_FOR_reduc_smax_scal_v16hi },
  { 0x12700037, CODE_FOR_reduc_smax_scal_v8si },
  { 0x12700038, CODE_FOR_reduc_smax_scal_v4di },
  { 0x12700045, CODE_FOR_reduc_smax_scal_v4sf },
  { 0x12700046, CODE_FOR_reduc_smax_scal_v2df },
  { 0x12700047, CODE_FOR_reduc_smax_scal_v8sf },
  { 0x12700048, CODE_FOR_reduc_smax_scal_v4df },
  { 0x12800031, CODE_FOR_reduc_smin_scal_v16qi },
  { 0x12800032, CODE_FOR_reduc_smin_scal_v8hi },
  { 0x12800033, CODE_FOR_reduc_smin_scal_v4si },
  { 0x12800034, CODE_FOR_reduc_smin_scal_v2di },
  { 0x12800035, CODE_FOR_reduc_smin_scal_v32qi },
  { 0x12800036, CODE_FOR_reduc_smin_scal_v16hi },
  { 0x12800037, CODE_FOR_reduc_smin_scal_v8si },
  { 0x12800038, CODE_FOR_reduc_smin_scal_v4di },
  { 0x12800045, CODE_FOR_reduc_smin_scal_v4sf },
  { 0x12800046, CODE_FOR_reduc_smin_scal_v2df },
  { 0x12800047, CODE_FOR_reduc_smin_scal_v8sf },
  { 0x12800048, CODE_FOR_reduc_smin_scal_v4df },
  { 0x12900033, CODE_FOR_reduc_plus_scal_v4si },
  { 0x12900034, CODE_FOR_reduc_plus_scal_v2di },
  { 0x12900037, CODE_FOR_reduc_plus_scal_v8si },
  { 0x12900038, CODE_FOR_reduc_plus_scal_v4di },
  { 0x12900045, CODE_FOR_reduc_plus_scal_v4sf },
  { 0x12900046, CODE_FOR_reduc_plus_scal_v2df },
  { 0x12900047, CODE_FOR_reduc_plus_scal_v8sf },
  { 0x12900048, CODE_FOR_reduc_plus_scal_v4df },
  { 0x12a00031, CODE_FOR_reduc_umax_scal_v16qi },
  { 0x12a00032, CODE_FOR_reduc_umax_scal_v8hi },
  { 0x12a00033, CODE_FOR_reduc_umax_scal_v4si },
  { 0x12a00034, CODE_FOR_reduc_umax_scal_v2di },
  { 0x12a00035, CODE_FOR_reduc_umax_scal_v32qi },
  { 0x12a00036, CODE_FOR_reduc_umax_scal_v16hi },
  { 0x12a00037, CODE_FOR_reduc_umax_scal_v8si },
  { 0x12a00038, CODE_FOR_reduc_umax_scal_v4di },
  { 0x12b00031, CODE_FOR_reduc_umin_scal_v16qi },
  { 0x12b00032, CODE_FOR_reduc_umin_scal_v8hi },
  { 0x12b00033, CODE_FOR_reduc_umin_scal_v4si },
  { 0x12b00034, CODE_FOR_reduc_umin_scal_v2di },
  { 0x12b00035, CODE_FOR_reduc_umin_scal_v32qi },
  { 0x12b00036, CODE_FOR_reduc_umin_scal_v16hi },
  { 0x12b00037, CODE_FOR_reduc_umin_scal_v8si },
  { 0x12b00038, CODE_FOR_reduc_umin_scal_v4di },
  { 0x12c00031, CODE_FOR_reduc_and_scal_v16qi },
  { 0x12c00032, CODE_FOR_reduc_and_scal_v8hi },
  { 0x12c00033, CODE_FOR_reduc_and_scal_v4si },
  { 0x12c00034, CODE_FOR_reduc_and_scal_v2di },
  { 0x12c00035, CODE_FOR_reduc_and_scal_v32qi },
  { 0x12c00036, CODE_FOR_reduc_and_scal_v16hi },
  { 0x12c00037, CODE_FOR_reduc_and_scal_v8si },
  { 0x12c00038, CODE_FOR_reduc_and_scal_v4di },
  { 0x12d00031, CODE_FOR_reduc_ior_scal_v16qi },
  { 0x12d00032, CODE_FOR_reduc_ior_scal_v8hi },
  { 0x12d00033, CODE_FOR_reduc_ior_scal_v4si },
  { 0x12d00034, CODE_FOR_reduc_ior_scal_v2di },
  { 0x12d00035, CODE_FOR_reduc_ior_scal_v32qi },
  { 0x12d00036, CODE_FOR_reduc_ior_scal_v16hi },
  { 0x12d00037, CODE_FOR_reduc_ior_scal_v8si },
  { 0x12d00038, CODE_FOR_reduc_ior_scal_v4di },
  { 0x12e00031, CODE_FOR_reduc_xor_scal_v16qi },
  { 0x12e00032, CODE_FOR_reduc_xor_scal_v8hi },
  { 0x12e00033, CODE_FOR_reduc_xor_scal_v4si },
  { 0x12e00034, CODE_FOR_reduc_xor_scal_v2di },
  { 0x12e00035, CODE_FOR_reduc_xor_scal_v32qi },
  { 0x12e00036, CODE_FOR_reduc_xor_scal_v16hi },
  { 0x12e00037, CODE_FOR_reduc_xor_scal_v8si },
  { 0x12e00038, CODE_FOR_reduc_xor_scal_v4di },
  { 0x13700031, CODE_FOR_avgv16qi3_floor },
  { 0x13700032, CODE_FOR_avgv8hi3_floor },
  { 0x13700033, CODE_FOR_avgv4si3_floor },
  { 0x13700035, CODE_FOR_avgv32qi3_floor },
  { 0x13700036, CODE_FOR_avgv16hi3_floor },
  { 0x13700037, CODE_FOR_avgv8si3_floor },
  { 0x13800031, CODE_FOR_uavgv16qi3_floor },
  { 0x13800032, CODE_FOR_uavgv8hi3_floor },
  { 0x13800033, CODE_FOR_uavgv4si3_floor },
  { 0x13800035, CODE_FOR_uavgv32qi3_floor },
  { 0x13800036, CODE_FOR_uavgv16hi3_floor },
  { 0x13800037, CODE_FOR_uavgv8si3_floor },
  { 0x13900031, CODE_FOR_avgv16qi3_ceil },
  { 0x13900032, CODE_FOR_avgv8hi3_ceil },
  { 0x13900033, CODE_FOR_avgv4si3_ceil },
  { 0x13900035, CODE_FOR_avgv32qi3_ceil },
  { 0x13900036, CODE_FOR_avgv16hi3_ceil },
  { 0x13900037, CODE_FOR_avgv8si3_ceil },
  { 0x13a00031, CODE_FOR_uavgv16qi3_ceil },
  { 0x13a00032, CODE_FOR_uavgv8hi3_ceil },
  { 0x13a00033, CODE_FOR_uavgv4si3_ceil },
  { 0x13a00035, CODE_FOR_uavgv32qi3_ceil },
  { 0x13a00036, CODE_FOR_uavgv16hi3_ceil },
  { 0x13a00037, CODE_FOR_uavgv8si3_ceil },
  { 0x14000031, CODE_FOR_usadv16qi },
  { 0x14000035, CODE_FOR_usadv32qi },
  { 0x14100031, CODE_FOR_ssadv16qi },
  { 0x14100035, CODE_FOR_ssadv32qi },
  { 0x14900032, CODE_FOR_vec_pack_trunc_v8hi },
  { 0x14900033, CODE_FOR_vec_pack_trunc_v4si },
  { 0x14900034, CODE_FOR_vec_pack_trunc_v2di },
  { 0x14900036, CODE_FOR_vec_pack_trunc_v16hi },
  { 0x14900037, CODE_FOR_vec_pack_trunc_v8si },
  { 0x14900038, CODE_FOR_vec_pack_trunc_v4di },
  { 0x14900046, CODE_FOR_vec_pack_trunc_v2df },
  { 0x14900048, CODE_FOR_vec_pack_trunc_v4df },
  { 0x14f00031, CODE_FOR_vec_permv16qi },
  { 0x14f00032, CODE_FOR_vec_permv8hi },
  { 0x14f00033, CODE_FOR_vec_permv4si },
  { 0x14f00034, CODE_FOR_vec_permv2di },
  { 0x14f00035, CODE_FOR_vec_permv32qi },
  { 0x14f00036, CODE_FOR_vec_permv16hi },
  { 0x14f00037, CODE_FOR_vec_permv8si },
  { 0x14f00038, CODE_FOR_vec_permv4di },
  { 0x14f00045, CODE_FOR_vec_permv4sf },
  { 0x14f00046, CODE_FOR_vec_permv2df },
  { 0x14f00047, CODE_FOR_vec_permv8sf },
  { 0x14f00048, CODE_FOR_vec_permv4df },
  { 0x15100031, CODE_FOR_vec_setv16qi },
  { 0x15100032, CODE_FOR_vec_setv8hi },
  { 0x15100033, CODE_FOR_vec_setv4si },
  { 0x15100034, CODE_FOR_vec_setv2di },
  { 0x15100037, CODE_FOR_vec_setv8si },
  { 0x15100038, CODE_FOR_vec_setv4di },
  { 0x15100045, CODE_FOR_vec_setv4sf },
  { 0x15100046, CODE_FOR_vec_setv2df },
  { 0x15100047, CODE_FOR_vec_setv8sf },
  { 0x15100048, CODE_FOR_vec_setv4df },
  { 0x15a00031, CODE_FOR_vec_unpacks_hi_v16qi },
  { 0x15a00032, CODE_FOR_vec_unpacks_hi_v8hi },
  { 0x15a00033, CODE_FOR_vec_unpacks_hi_v4si },
  { 0x15a00035, CODE_FOR_vec_unpacks_hi_v32qi },
  { 0x15a00036, CODE_FOR_vec_unpacks_hi_v16hi },
  { 0x15a00037, CODE_FOR_vec_unpacks_hi_v8si },
  { 0x15a00045, CODE_FOR_vec_unpacks_hi_v4sf },
  { 0x15a00047, CODE_FOR_vec_unpacks_hi_v8sf },
  { 0x15b00031, CODE_FOR_vec_unpacks_lo_v16qi },
  { 0x15b00032, CODE_FOR_vec_unpacks_lo_v8hi },
  { 0x15b00033, CODE_FOR_vec_unpacks_lo_v4si },
  { 0x15b00035, CODE_FOR_vec_unpacks_lo_v32qi },
  { 0x15b00036, CODE_FOR_vec_unpacks_lo_v16hi },
  { 0x15b00037, CODE_FOR_vec_unpacks_lo_v8si },
  { 0x15b00045, CODE_FOR_vec_unpacks_lo_v4sf },
  { 0x15b00047, CODE_FOR_vec_unpacks_lo_v8sf },
  { 0x16000031, CODE_FOR_vec_unpacku_hi_v16qi },
  { 0x16000032, CODE_FOR_vec_unpacku_hi_v8hi },
  { 0x16000033, CODE_FOR_vec_unpacku_hi_v4si },
  { 0x16000035, CODE_FOR_vec_unpacku_hi_v32qi },
  { 0x16000036, CODE_FOR_vec_unpacku_hi_v16hi },
  { 0x16000037, CODE_FOR_vec_unpacku_hi_v8si },
  { 0x16100031, CODE_FOR_vec_unpacku_lo_v16qi },
  { 0x16100032, CODE_FOR_vec_unpacku_lo_v8hi },
  { 0x16100033, CODE_FOR_vec_unpacku_lo_v4si },
  { 0x16100035, CODE_FOR_vec_unpacku_lo_v32qi },
  { 0x16100036, CODE_FOR_vec_unpacku_lo_v16hi },
  { 0x16100037, CODE_FOR_vec_unpacku_lo_v8si },
  { 0x16300035, CODE_FOR_vec_widen_smult_hi_v32qi },
  { 0x16300036, CODE_FOR_vec_widen_smult_hi_v16hi },
  { 0x16400035, CODE_FOR_vec_widen_smult_lo_v32qi },
  { 0x16400036, CODE_FOR_vec_widen_smult_lo_v16hi },
  { 0x16700035, CODE_FOR_vec_widen_ssub_hi_v32qi },
  { 0x16700036, CODE_FOR_vec_widen_ssub_hi_v16hi },
  { 0x16800035, CODE_FOR_vec_widen_ssub_lo_v32qi },
  { 0x16800036, CODE_FOR_vec_widen_ssub_lo_v16hi },
  { 0x16c00035, CODE_FOR_vec_widen_sadd_hi_v32qi },
  { 0x16c00036, CODE_FOR_vec_widen_sadd_hi_v16hi },
  { 0x16d00035, CODE_FOR_vec_widen_sadd_lo_v32qi },
  { 0x16d00036, CODE_FOR_vec_widen_sadd_lo_v16hi },
  { 0x17800035, CODE_FOR_vec_widen_umult_hi_v32qi },
  { 0x17800036, CODE_FOR_vec_widen_umult_hi_v16hi },
  { 0x17900035, CODE_FOR_vec_widen_umult_lo_v32qi },
  { 0x17900036, CODE_FOR_vec_widen_umult_lo_v16hi },
  { 0x17e00035, CODE_FOR_vec_widen_usub_hi_v32qi },
  { 0x17e00036, CODE_FOR_vec_widen_usub_hi_v16hi },
  { 0x17f00035, CODE_FOR_vec_widen_usub_lo_v32qi },
  { 0x17f00036, CODE_FOR_vec_widen_usub_lo_v16hi },
  { 0x18300035, CODE_FOR_vec_widen_uadd_hi_v32qi },
  { 0x18300036, CODE_FOR_vec_widen_uadd_hi_v16hi },
  { 0x18400035, CODE_FOR_vec_widen_uadd_lo_v32qi },
  { 0x18400036, CODE_FOR_vec_widen_uadd_lo_v16hi },
  { 0x19700005, CODE_FOR_atomic_addqi },
  { 0x19700006, CODE_FOR_atomic_addhi },
  { 0x19700007, CODE_FOR_atomic_addsi },
  { 0x19700008, CODE_FOR_atomic_adddi },
  { 0x19900007, CODE_FOR_atomic_andsi },
  { 0x19900008, CODE_FOR_atomic_anddi },
  { 0x19d00005, CODE_FOR_atomic_compare_and_swapqi },
  { 0x19d00006, CODE_FOR_atomic_compare_and_swaphi },
  { 0x19d00007, CODE_FOR_atomic_compare_and_swapsi },
  { 0x19d00008, CODE_FOR_atomic_compare_and_swapdi },
  { 0x19e00005, CODE_FOR_atomic_exchangeqi },
  { 0x19e00006, CODE_FOR_atomic_exchangehi },
  { 0x19e00007, CODE_FOR_atomic_exchangesi },
  { 0x19e00008, CODE_FOR_atomic_exchangedi },
  { 0x19f00005, CODE_FOR_atomic_fetch_addqi },
  { 0x19f00006, CODE_FOR_atomic_fetch_addhi },
  { 0x19f00007, CODE_FOR_atomic_fetch_addsi },
  { 0x19f00008, CODE_FOR_atomic_fetch_adddi },
  { 0x1a000005, CODE_FOR_atomic_fetch_andqi },
  { 0x1a000006, CODE_FOR_atomic_fetch_andhi },
  { 0x1a000007, CODE_FOR_atomic_fetch_andsi },
  { 0x1a000008, CODE_FOR_atomic_fetch_anddi },
  { 0x1a100005, CODE_FOR_atomic_fetch_nandqi },
  { 0x1a100006, CODE_FOR_atomic_fetch_nandhi },
  { 0x1a200005, CODE_FOR_atomic_fetch_orqi },
  { 0x1a200006, CODE_FOR_atomic_fetch_orhi },
  { 0x1a200007, CODE_FOR_atomic_fetch_orsi },
  { 0x1a200008, CODE_FOR_atomic_fetch_ordi },
  { 0x1a300005, CODE_FOR_atomic_fetch_subqi },
  { 0x1a300006, CODE_FOR_atomic_fetch_subhi },
  { 0x1a400005, CODE_FOR_atomic_fetch_xorqi },
  { 0x1a400006, CODE_FOR_atomic_fetch_xorhi },
  { 0x1a400007, CODE_FOR_atomic_fetch_xorsi },
  { 0x1a400008, CODE_FOR_atomic_fetch_xordi },
  { 0x1a500005, CODE_FOR_atomic_loadqi },
  { 0x1a500006, CODE_FOR_atomic_loadhi },
  { 0x1a500007, CODE_FOR_atomic_loadsi },
  { 0x1a500008, CODE_FOR_atomic_loaddi },
  { 0x1a900007, CODE_FOR_atomic_orsi },
  { 0x1a900008, CODE_FOR_atomic_ordi },
  { 0x1aa00005, CODE_FOR_atomic_storeqi },
  { 0x1aa00006, CODE_FOR_atomic_storehi },
  { 0x1aa00007, CODE_FOR_atomic_storesi },
  { 0x1aa00008, CODE_FOR_atomic_storedi },
  { 0x1ae00007, CODE_FOR_atomic_xorsi },
  { 0x1ae00008, CODE_FOR_atomic_xordi },
  { 0x1b400007, CODE_FOR_get_thread_pointersi },
  { 0x1b400008, CODE_FOR_get_thread_pointerdi },
};

void
init_all_optabs (struct target_optabs *optabs)
{
  bool *ena = optabs->pat_enable;
  ena[0] = HAVE_extendqihi2;
  ena[1] = HAVE_extendqisi2;
  ena[2] = HAVE_extendqidi2;
  ena[3] = HAVE_extendhisi2;
  ena[4] = HAVE_extendhidi2;
  ena[5] = HAVE_extendsidi2;
  ena[6] = HAVE_extendsfdf2;
  ena[7] = HAVE_truncdfsf2;
  ena[8] = HAVE_zero_extendqihi2;
  ena[9] = HAVE_zero_extendqisi2;
  ena[10] = HAVE_zero_extendqidi2;
  ena[11] = HAVE_zero_extendhisi2;
  ena[12] = HAVE_zero_extendhidi2;
  ena[13] = HAVE_zero_extendsidi2;
  ena[14] = HAVE_floatsisf2;
  ena[15] = HAVE_floatsidf2;
  ena[16] = HAVE_floatdisf2;
  ena[17] = HAVE_floatdidf2;
  ena[18] = HAVE_floatv4siv4sf2;
  ena[19] = HAVE_floatv2div2df2;
  ena[20] = HAVE_floatv8siv8sf2;
  ena[21] = HAVE_floatv4div4df2;
  ena[22] = HAVE_floatunsv4siv4sf2;
  ena[23] = HAVE_floatunsv2div2df2;
  ena[24] = HAVE_floatunsv8siv8sf2;
  ena[25] = HAVE_floatunsv4div4df2;
  ena[26] = HAVE_lrintsfsi2;
  ena[27] = HAVE_lrintsfdi2;
  ena[28] = HAVE_lrintdfsi2;
  ena[29] = HAVE_lrintdfdi2;
  ena[30] = HAVE_lrintv4sfv4si2;
  ena[31] = HAVE_lrintv2dfv2di2;
  ena[32] = HAVE_lrintv8sfv8si2;
  ena[33] = HAVE_lrintv4dfv4di2;
  ena[34] = HAVE_lfloorsfsi2;
  ena[35] = HAVE_lfloorsfdi2;
  ena[36] = HAVE_lfloordfsi2;
  ena[37] = HAVE_lfloordfdi2;
  ena[38] = HAVE_lfloorv4sfv4si2;
  ena[39] = HAVE_lfloorv2dfv2di2;
  ena[40] = HAVE_lfloorv8sfv8si2;
  ena[41] = HAVE_lfloorv4dfv4di2;
  ena[42] = HAVE_lceilsfsi2;
  ena[43] = HAVE_lceilsfdi2;
  ena[44] = HAVE_lceildfsi2;
  ena[45] = HAVE_lceildfdi2;
  ena[46] = HAVE_lceilv4sfv4si2;
  ena[47] = HAVE_lceilv2dfv2di2;
  ena[48] = HAVE_lceilv8sfv8si2;
  ena[49] = HAVE_lceilv4dfv4di2;
  ena[50] = HAVE_fix_truncsfsi2;
  ena[51] = HAVE_fix_truncsfdi2;
  ena[52] = HAVE_fix_truncdfsi2;
  ena[53] = HAVE_fix_truncdfdi2;
  ena[54] = HAVE_fix_truncv4sfv4si2;
  ena[55] = HAVE_fix_truncv2dfv2di2;
  ena[56] = HAVE_fix_truncv8sfv8si2;
  ena[57] = HAVE_fix_truncv4dfv4di2;
  ena[58] = HAVE_fixuns_truncsfsi2;
  ena[59] = HAVE_fixuns_truncsfdi2;
  ena[60] = HAVE_fixuns_truncdfsi2;
  ena[61] = HAVE_fixuns_truncdfdi2;
  ena[62] = HAVE_fixuns_truncv4sfv4si2;
  ena[63] = HAVE_fixuns_truncv2dfv2di2;
  ena[64] = HAVE_fixuns_truncv8sfv8si2;
  ena[65] = HAVE_fixuns_truncv4dfv4di2;
  ena[66] = HAVE_mulsidi3;
  ena[67] = HAVE_mulditi3;
  ena[68] = HAVE_umulsidi3;
  ena[69] = HAVE_umulditi3;
  ena[70] = HAVE_vcondv16qiv16qi;
  ena[71] = HAVE_vcondv8hiv16qi;
  ena[72] = HAVE_vcondv4siv16qi;
  ena[73] = HAVE_vcondv2div16qi;
  ena[74] = HAVE_vcondv4sfv16qi;
  ena[75] = HAVE_vcondv2dfv16qi;
  ena[76] = HAVE_vcondv16qiv8hi;
  ena[77] = HAVE_vcondv8hiv8hi;
  ena[78] = HAVE_vcondv4siv8hi;
  ena[79] = HAVE_vcondv2div8hi;
  ena[80] = HAVE_vcondv4sfv8hi;
  ena[81] = HAVE_vcondv2dfv8hi;
  ena[82] = HAVE_vcondv16qiv4si;
  ena[83] = HAVE_vcondv8hiv4si;
  ena[84] = HAVE_vcondv4siv4si;
  ena[85] = HAVE_vcondv2div4si;
  ena[86] = HAVE_vcondv4sfv4si;
  ena[87] = HAVE_vcondv2dfv4si;
  ena[88] = HAVE_vcondv16qiv2di;
  ena[89] = HAVE_vcondv8hiv2di;
  ena[90] = HAVE_vcondv4siv2di;
  ena[91] = HAVE_vcondv2div2di;
  ena[92] = HAVE_vcondv4sfv2di;
  ena[93] = HAVE_vcondv2dfv2di;
  ena[94] = HAVE_vcondv32qiv32qi;
  ena[95] = HAVE_vcondv16hiv32qi;
  ena[96] = HAVE_vcondv8siv32qi;
  ena[97] = HAVE_vcondv4div32qi;
  ena[98] = HAVE_vcondv8sfv32qi;
  ena[99] = HAVE_vcondv4dfv32qi;
  ena[100] = HAVE_vcondv32qiv16hi;
  ena[101] = HAVE_vcondv16hiv16hi;
  ena[102] = HAVE_vcondv8siv16hi;
  ena[103] = HAVE_vcondv4div16hi;
  ena[104] = HAVE_vcondv8sfv16hi;
  ena[105] = HAVE_vcondv4dfv16hi;
  ena[106] = HAVE_vcondv32qiv8si;
  ena[107] = HAVE_vcondv16hiv8si;
  ena[108] = HAVE_vcondv8siv8si;
  ena[109] = HAVE_vcondv4div8si;
  ena[110] = HAVE_vcondv8sfv8si;
  ena[111] = HAVE_vcondv4dfv8si;
  ena[112] = HAVE_vcondv32qiv4di;
  ena[113] = HAVE_vcondv16hiv4di;
  ena[114] = HAVE_vcondv8siv4di;
  ena[115] = HAVE_vcondv4div4di;
  ena[116] = HAVE_vcondv8sfv4di;
  ena[117] = HAVE_vcondv4dfv4di;
  ena[118] = HAVE_vcondv16qiv4sf;
  ena[119] = HAVE_vcondv8hiv4sf;
  ena[120] = HAVE_vcondv4siv4sf;
  ena[121] = HAVE_vcondv2div4sf;
  ena[122] = HAVE_vcondv4sfv4sf;
  ena[123] = HAVE_vcondv2dfv4sf;
  ena[124] = HAVE_vcondv16qiv2df;
  ena[125] = HAVE_vcondv8hiv2df;
  ena[126] = HAVE_vcondv4siv2df;
  ena[127] = HAVE_vcondv2div2df;
  ena[128] = HAVE_vcondv4sfv2df;
  ena[129] = HAVE_vcondv2dfv2df;
  ena[130] = HAVE_vcondv32qiv8sf;
  ena[131] = HAVE_vcondv16hiv8sf;
  ena[132] = HAVE_vcondv8siv8sf;
  ena[133] = HAVE_vcondv4div8sf;
  ena[134] = HAVE_vcondv8sfv8sf;
  ena[135] = HAVE_vcondv4dfv8sf;
  ena[136] = HAVE_vcondv32qiv4df;
  ena[137] = HAVE_vcondv16hiv4df;
  ena[138] = HAVE_vcondv8siv4df;
  ena[139] = HAVE_vcondv4div4df;
  ena[140] = HAVE_vcondv8sfv4df;
  ena[141] = HAVE_vcondv4dfv4df;
  ena[142] = HAVE_vconduv16qiv16qi;
  ena[143] = HAVE_vconduv8hiv16qi;
  ena[144] = HAVE_vconduv4siv16qi;
  ena[145] = HAVE_vconduv2div16qi;
  ena[146] = HAVE_vconduv4sfv16qi;
  ena[147] = HAVE_vconduv2dfv16qi;
  ena[148] = HAVE_vconduv16qiv8hi;
  ena[149] = HAVE_vconduv8hiv8hi;
  ena[150] = HAVE_vconduv4siv8hi;
  ena[151] = HAVE_vconduv2div8hi;
  ena[152] = HAVE_vconduv4sfv8hi;
  ena[153] = HAVE_vconduv2dfv8hi;
  ena[154] = HAVE_vconduv16qiv4si;
  ena[155] = HAVE_vconduv8hiv4si;
  ena[156] = HAVE_vconduv4siv4si;
  ena[157] = HAVE_vconduv2div4si;
  ena[158] = HAVE_vconduv4sfv4si;
  ena[159] = HAVE_vconduv2dfv4si;
  ena[160] = HAVE_vconduv16qiv2di;
  ena[161] = HAVE_vconduv8hiv2di;
  ena[162] = HAVE_vconduv4siv2di;
  ena[163] = HAVE_vconduv2div2di;
  ena[164] = HAVE_vconduv4sfv2di;
  ena[165] = HAVE_vconduv2dfv2di;
  ena[166] = HAVE_vconduv32qiv32qi;
  ena[167] = HAVE_vconduv16hiv32qi;
  ena[168] = HAVE_vconduv8siv32qi;
  ena[169] = HAVE_vconduv4div32qi;
  ena[170] = HAVE_vconduv8sfv32qi;
  ena[171] = HAVE_vconduv4dfv32qi;
  ena[172] = HAVE_vconduv32qiv16hi;
  ena[173] = HAVE_vconduv16hiv16hi;
  ena[174] = HAVE_vconduv8siv16hi;
  ena[175] = HAVE_vconduv4div16hi;
  ena[176] = HAVE_vconduv8sfv16hi;
  ena[177] = HAVE_vconduv4dfv16hi;
  ena[178] = HAVE_vconduv32qiv8si;
  ena[179] = HAVE_vconduv16hiv8si;
  ena[180] = HAVE_vconduv8siv8si;
  ena[181] = HAVE_vconduv4div8si;
  ena[182] = HAVE_vconduv8sfv8si;
  ena[183] = HAVE_vconduv4dfv8si;
  ena[184] = HAVE_vconduv32qiv4di;
  ena[185] = HAVE_vconduv16hiv4di;
  ena[186] = HAVE_vconduv8siv4di;
  ena[187] = HAVE_vconduv4div4di;
  ena[188] = HAVE_vconduv8sfv4di;
  ena[189] = HAVE_vconduv4dfv4di;
  ena[190] = HAVE_vcond_mask_v16qiv16qi;
  ena[191] = HAVE_vcond_mask_v8hiv8hi;
  ena[192] = HAVE_vcond_mask_v4siv4si;
  ena[193] = HAVE_vcond_mask_v4sfv4si;
  ena[194] = HAVE_vcond_mask_v2div2di;
  ena[195] = HAVE_vcond_mask_v2dfv2di;
  ena[196] = HAVE_vcond_mask_v32qiv32qi;
  ena[197] = HAVE_vcond_mask_v16hiv16hi;
  ena[198] = HAVE_vcond_mask_v8siv8si;
  ena[199] = HAVE_vcond_mask_v8sfv8si;
  ena[200] = HAVE_vcond_mask_v4div4di;
  ena[201] = HAVE_vcond_mask_v4dfv4di;
  ena[202] = HAVE_vec_cmpv16qiv16qi;
  ena[203] = HAVE_vec_cmpv8hiv8hi;
  ena[204] = HAVE_vec_cmpv4siv4si;
  ena[205] = HAVE_vec_cmpv4sfv4si;
  ena[206] = HAVE_vec_cmpv2div2di;
  ena[207] = HAVE_vec_cmpv2dfv2di;
  ena[208] = HAVE_vec_cmpv32qiv32qi;
  ena[209] = HAVE_vec_cmpv16hiv16hi;
  ena[210] = HAVE_vec_cmpv8siv8si;
  ena[211] = HAVE_vec_cmpv8sfv8si;
  ena[212] = HAVE_vec_cmpv4div4di;
  ena[213] = HAVE_vec_cmpv4dfv4di;
  ena[214] = HAVE_vec_cmpuv16qiv16qi;
  ena[215] = HAVE_vec_cmpuv8hiv8hi;
  ena[216] = HAVE_vec_cmpuv4siv4si;
  ena[217] = HAVE_vec_cmpuv2div2di;
  ena[218] = HAVE_vec_cmpuv32qiv32qi;
  ena[219] = HAVE_vec_cmpuv16hiv16hi;
  ena[220] = HAVE_vec_cmpuv8siv8si;
  ena[221] = HAVE_vec_cmpuv4div4di;
  ena[222] = HAVE_vec_extractv16qiqi;
  ena[223] = HAVE_vec_extractv32qiqi;
  ena[224] = HAVE_vec_extractv8hihi;
  ena[225] = HAVE_vec_extractv16hihi;
  ena[226] = HAVE_vec_extractv4sisi;
  ena[227] = HAVE_vec_extractv8sisi;
  ena[228] = HAVE_vec_extractv2didi;
  ena[229] = HAVE_vec_extractv4didi;
  ena[230] = HAVE_vec_extractv4sfsf;
  ena[231] = HAVE_vec_extractv8sfsf;
  ena[232] = HAVE_vec_extractv2dfdf;
  ena[233] = HAVE_vec_extractv4dfdf;
  ena[234] = HAVE_vec_initv16qiqi;
  ena[235] = HAVE_vec_initv32qiqi;
  ena[236] = HAVE_vec_initv8hihi;
  ena[237] = HAVE_vec_initv16hihi;
  ena[238] = HAVE_vec_initv4sisi;
  ena[239] = HAVE_vec_initv8sisi;
  ena[240] = HAVE_vec_initv2didi;
  ena[241] = HAVE_vec_initv4didi;
  ena[242] = HAVE_vec_initv4sfsf;
  ena[243] = HAVE_vec_initv8sfsf;
  ena[244] = HAVE_vec_initv2dfdf;
  ena[245] = HAVE_vec_initv4dfdf;
  ena[246] = HAVE_vec_initv32qiv16qi;
  ena[247] = HAVE_vec_initv16hiv8hi;
  ena[248] = HAVE_vec_initv8siv4si;
  ena[249] = HAVE_vec_initv4div2di;
  ena[250] = HAVE_vec_initv8sfv4sf;
  ena[251] = HAVE_vec_initv4dfv2df;
  ena[252] = HAVE_addsi3;
  ena[253] = HAVE_adddi3;
  ena[254] = HAVE_addsf3;
  ena[255] = HAVE_adddf3;
  ena[256] = HAVE_addv16qi3;
  ena[257] = HAVE_addv8hi3;
  ena[258] = HAVE_addv4si3;
  ena[259] = HAVE_addv2di3;
  ena[260] = HAVE_addv32qi3;
  ena[261] = HAVE_addv16hi3;
  ena[262] = HAVE_addv8si3;
  ena[263] = HAVE_addv4di3;
  ena[264] = HAVE_addv4sf3;
  ena[265] = HAVE_addv2df3;
  ena[266] = HAVE_addv8sf3;
  ena[267] = HAVE_addv4df3;
  ena[268] = HAVE_subsi3;
  ena[269] = HAVE_subdi3;
  ena[270] = HAVE_subsf3;
  ena[271] = HAVE_subdf3;
  ena[272] = HAVE_subv16qi3;
  ena[273] = HAVE_subv8hi3;
  ena[274] = HAVE_subv4si3;
  ena[275] = HAVE_subv2di3;
  ena[276] = HAVE_subv32qi3;
  ena[277] = HAVE_subv16hi3;
  ena[278] = HAVE_subv8si3;
  ena[279] = HAVE_subv4di3;
  ena[280] = HAVE_subv4sf3;
  ena[281] = HAVE_subv2df3;
  ena[282] = HAVE_subv8sf3;
  ena[283] = HAVE_subv4df3;
  ena[284] = HAVE_mulsi3;
  ena[285] = HAVE_muldi3;
  ena[286] = HAVE_mulsf3;
  ena[287] = HAVE_muldf3;
  ena[288] = HAVE_mulv16qi3;
  ena[289] = HAVE_mulv8hi3;
  ena[290] = HAVE_mulv4si3;
  ena[291] = HAVE_mulv2di3;
  ena[292] = HAVE_mulv32qi3;
  ena[293] = HAVE_mulv16hi3;
  ena[294] = HAVE_mulv8si3;
  ena[295] = HAVE_mulv4di3;
  ena[296] = HAVE_mulv4sf3;
  ena[297] = HAVE_mulv2df3;
  ena[298] = HAVE_mulv8sf3;
  ena[299] = HAVE_mulv4df3;
  ena[300] = HAVE_divsi3;
  ena[301] = HAVE_divdi3;
  ena[302] = HAVE_divsf3;
  ena[303] = HAVE_divdf3;
  ena[304] = HAVE_divv16qi3;
  ena[305] = HAVE_divv8hi3;
  ena[306] = HAVE_divv4si3;
  ena[307] = HAVE_divv2di3;
  ena[308] = HAVE_divv32qi3;
  ena[309] = HAVE_divv16hi3;
  ena[310] = HAVE_divv8si3;
  ena[311] = HAVE_divv4di3;
  ena[312] = HAVE_divv4sf3;
  ena[313] = HAVE_divv2df3;
  ena[314] = HAVE_divv8sf3;
  ena[315] = HAVE_divv4df3;
  ena[316] = HAVE_udivsi3;
  ena[317] = HAVE_udivdi3;
  ena[318] = HAVE_udivv16qi3;
  ena[319] = HAVE_udivv8hi3;
  ena[320] = HAVE_udivv4si3;
  ena[321] = HAVE_udivv2di3;
  ena[322] = HAVE_udivv32qi3;
  ena[323] = HAVE_udivv16hi3;
  ena[324] = HAVE_udivv8si3;
  ena[325] = HAVE_udivv4di3;
  ena[326] = HAVE_modsi3;
  ena[327] = HAVE_moddi3;
  ena[328] = HAVE_modv16qi3;
  ena[329] = HAVE_modv8hi3;
  ena[330] = HAVE_modv4si3;
  ena[331] = HAVE_modv2di3;
  ena[332] = HAVE_modv32qi3;
  ena[333] = HAVE_modv16hi3;
  ena[334] = HAVE_modv8si3;
  ena[335] = HAVE_modv4di3;
  ena[336] = HAVE_umodsi3;
  ena[337] = HAVE_umoddi3;
  ena[338] = HAVE_umodv16qi3;
  ena[339] = HAVE_umodv8hi3;
  ena[340] = HAVE_umodv4si3;
  ena[341] = HAVE_umodv2di3;
  ena[342] = HAVE_umodv32qi3;
  ena[343] = HAVE_umodv16hi3;
  ena[344] = HAVE_umodv8si3;
  ena[345] = HAVE_umodv4di3;
  ena[346] = HAVE_ftruncv4sf2;
  ena[347] = HAVE_ftruncv2df2;
  ena[348] = HAVE_ftruncv8sf2;
  ena[349] = HAVE_ftruncv4df2;
  ena[350] = HAVE_andsi3;
  ena[351] = HAVE_anddi3;
  ena[352] = HAVE_andv16qi3;
  ena[353] = HAVE_andv8hi3;
  ena[354] = HAVE_andv4si3;
  ena[355] = HAVE_andv2di3;
  ena[356] = HAVE_andv32qi3;
  ena[357] = HAVE_andv16hi3;
  ena[358] = HAVE_andv8si3;
  ena[359] = HAVE_andv4di3;
  ena[360] = HAVE_andv4sf3;
  ena[361] = HAVE_andv2df3;
  ena[362] = HAVE_andv8sf3;
  ena[363] = HAVE_andv4df3;
  ena[364] = HAVE_iorsi3;
  ena[365] = HAVE_iordi3;
  ena[366] = HAVE_iorv16qi3;
  ena[367] = HAVE_iorv8hi3;
  ena[368] = HAVE_iorv4si3;
  ena[369] = HAVE_iorv2di3;
  ena[370] = HAVE_iorv32qi3;
  ena[371] = HAVE_iorv16hi3;
  ena[372] = HAVE_iorv8si3;
  ena[373] = HAVE_iorv4di3;
  ena[374] = HAVE_iorv4sf3;
  ena[375] = HAVE_iorv2df3;
  ena[376] = HAVE_iorv8sf3;
  ena[377] = HAVE_iorv4df3;
  ena[378] = HAVE_xorsi3;
  ena[379] = HAVE_xordi3;
  ena[380] = HAVE_xorv16qi3;
  ena[381] = HAVE_xorv8hi3;
  ena[382] = HAVE_xorv4si3;
  ena[383] = HAVE_xorv2di3;
  ena[384] = HAVE_xorv32qi3;
  ena[385] = HAVE_xorv16hi3;
  ena[386] = HAVE_xorv8si3;
  ena[387] = HAVE_xorv4di3;
  ena[388] = HAVE_xorv4sf3;
  ena[389] = HAVE_xorv2df3;
  ena[390] = HAVE_xorv8sf3;
  ena[391] = HAVE_xorv4df3;
  ena[392] = HAVE_ashlsi3;
  ena[393] = HAVE_ashldi3;
  ena[394] = HAVE_ashrsi3;
  ena[395] = HAVE_ashrdi3;
  ena[396] = HAVE_lshrsi3;
  ena[397] = HAVE_lshrdi3;
  ena[398] = HAVE_rotlsi3;
  ena[399] = HAVE_rotldi3;
  ena[400] = HAVE_rotlv16qi3;
  ena[401] = HAVE_rotlv8hi3;
  ena[402] = HAVE_rotlv4si3;
  ena[403] = HAVE_rotlv2di3;
  ena[404] = HAVE_rotlv32qi3;
  ena[405] = HAVE_rotlv16hi3;
  ena[406] = HAVE_rotlv8si3;
  ena[407] = HAVE_rotlv4di3;
  ena[408] = HAVE_rotrsi3;
  ena[409] = HAVE_rotrdi3;
  ena[410] = HAVE_rotrv16qi3;
  ena[411] = HAVE_rotrv8hi3;
  ena[412] = HAVE_rotrv4si3;
  ena[413] = HAVE_rotrv2di3;
  ena[414] = HAVE_rotrv32qi3;
  ena[415] = HAVE_rotrv16hi3;
  ena[416] = HAVE_rotrv8si3;
  ena[417] = HAVE_rotrv4di3;
  ena[418] = HAVE_vashlv16qi3;
  ena[419] = HAVE_vashlv8hi3;
  ena[420] = HAVE_vashlv4si3;
  ena[421] = HAVE_vashlv2di3;
  ena[422] = HAVE_vashlv32qi3;
  ena[423] = HAVE_vashlv16hi3;
  ena[424] = HAVE_vashlv8si3;
  ena[425] = HAVE_vashlv4di3;
  ena[426] = HAVE_vashrv16qi3;
  ena[427] = HAVE_vashrv8hi3;
  ena[428] = HAVE_vashrv4si3;
  ena[429] = HAVE_vashrv2di3;
  ena[430] = HAVE_vashrv32qi3;
  ena[431] = HAVE_vashrv16hi3;
  ena[432] = HAVE_vashrv8si3;
  ena[433] = HAVE_vashrv4di3;
  ena[434] = HAVE_vlshrv16qi3;
  ena[435] = HAVE_vlshrv8hi3;
  ena[436] = HAVE_vlshrv4si3;
  ena[437] = HAVE_vlshrv2di3;
  ena[438] = HAVE_vlshrv32qi3;
  ena[439] = HAVE_vlshrv16hi3;
  ena[440] = HAVE_vlshrv8si3;
  ena[441] = HAVE_vlshrv4di3;
  ena[442] = HAVE_vrotlv16qi3;
  ena[443] = HAVE_vrotlv8hi3;
  ena[444] = HAVE_vrotlv4si3;
  ena[445] = HAVE_vrotlv2di3;
  ena[446] = HAVE_vrotlv32qi3;
  ena[447] = HAVE_vrotlv16hi3;
  ena[448] = HAVE_vrotlv8si3;
  ena[449] = HAVE_vrotlv4di3;
  ena[450] = HAVE_vrotrv16qi3;
  ena[451] = HAVE_vrotrv8hi3;
  ena[452] = HAVE_vrotrv4si3;
  ena[453] = HAVE_vrotrv2di3;
  ena[454] = HAVE_vrotrv32qi3;
  ena[455] = HAVE_vrotrv16hi3;
  ena[456] = HAVE_vrotrv8si3;
  ena[457] = HAVE_vrotrv4di3;
  ena[458] = HAVE_sminsf3;
  ena[459] = HAVE_smindf3;
  ena[460] = HAVE_sminv16qi3;
  ena[461] = HAVE_sminv8hi3;
  ena[462] = HAVE_sminv4si3;
  ena[463] = HAVE_sminv2di3;
  ena[464] = HAVE_sminv32qi3;
  ena[465] = HAVE_sminv16hi3;
  ena[466] = HAVE_sminv8si3;
  ena[467] = HAVE_sminv4di3;
  ena[468] = HAVE_sminv4sf3;
  ena[469] = HAVE_sminv2df3;
  ena[470] = HAVE_sminv8sf3;
  ena[471] = HAVE_sminv4df3;
  ena[472] = HAVE_smaxsf3;
  ena[473] = HAVE_smaxdf3;
  ena[474] = HAVE_smaxv16qi3;
  ena[475] = HAVE_smaxv8hi3;
  ena[476] = HAVE_smaxv4si3;
  ena[477] = HAVE_smaxv2di3;
  ena[478] = HAVE_smaxv32qi3;
  ena[479] = HAVE_smaxv16hi3;
  ena[480] = HAVE_smaxv8si3;
  ena[481] = HAVE_smaxv4di3;
  ena[482] = HAVE_smaxv4sf3;
  ena[483] = HAVE_smaxv2df3;
  ena[484] = HAVE_smaxv8sf3;
  ena[485] = HAVE_smaxv4df3;
  ena[486] = HAVE_uminv16qi3;
  ena[487] = HAVE_uminv8hi3;
  ena[488] = HAVE_uminv4si3;
  ena[489] = HAVE_uminv2di3;
  ena[490] = HAVE_uminv32qi3;
  ena[491] = HAVE_uminv16hi3;
  ena[492] = HAVE_uminv8si3;
  ena[493] = HAVE_uminv4di3;
  ena[494] = HAVE_umaxv16qi3;
  ena[495] = HAVE_umaxv8hi3;
  ena[496] = HAVE_umaxv4si3;
  ena[497] = HAVE_umaxv2di3;
  ena[498] = HAVE_umaxv32qi3;
  ena[499] = HAVE_umaxv16hi3;
  ena[500] = HAVE_umaxv8si3;
  ena[501] = HAVE_umaxv4di3;
  ena[502] = HAVE_negsi2;
  ena[503] = HAVE_negdi2;
  ena[504] = HAVE_negsf2;
  ena[505] = HAVE_negdf2;
  ena[506] = HAVE_negv16qi2;
  ena[507] = HAVE_negv8hi2;
  ena[508] = HAVE_negv4si2;
  ena[509] = HAVE_negv2di2;
  ena[510] = HAVE_negv32qi2;
  ena[511] = HAVE_negv16hi2;
  ena[512] = HAVE_negv8si2;
  ena[513] = HAVE_negv4di2;
  ena[514] = HAVE_negv4sf2;
  ena[515] = HAVE_negv2df2;
  ena[516] = HAVE_negv8sf2;
  ena[517] = HAVE_negv4df2;
  ena[518] = HAVE_abssf2;
  ena[519] = HAVE_absdf2;
  ena[520] = HAVE_absv16qi2;
  ena[521] = HAVE_absv8hi2;
  ena[522] = HAVE_absv4si2;
  ena[523] = HAVE_absv2di2;
  ena[524] = HAVE_absv32qi2;
  ena[525] = HAVE_absv16hi2;
  ena[526] = HAVE_absv8si2;
  ena[527] = HAVE_absv4di2;
  ena[528] = HAVE_absv4sf2;
  ena[529] = HAVE_absv2df2;
  ena[530] = HAVE_absv8sf2;
  ena[531] = HAVE_absv4df2;
  ena[532] = HAVE_one_cmplsi2;
  ena[533] = HAVE_one_cmpldi2;
  ena[534] = HAVE_one_cmplv16qi2;
  ena[535] = HAVE_one_cmplv8hi2;
  ena[536] = HAVE_one_cmplv4si2;
  ena[537] = HAVE_one_cmplv2di2;
  ena[538] = HAVE_one_cmplv32qi2;
  ena[539] = HAVE_one_cmplv16hi2;
  ena[540] = HAVE_one_cmplv8si2;
  ena[541] = HAVE_one_cmplv4di2;
  ena[542] = HAVE_bswaphi2;
  ena[543] = HAVE_bswapsi2;
  ena[544] = HAVE_bswapdi2;
  ena[545] = HAVE_clzsi2;
  ena[546] = HAVE_clzdi2;
  ena[547] = HAVE_clzv16qi2;
  ena[548] = HAVE_clzv8hi2;
  ena[549] = HAVE_clzv4si2;
  ena[550] = HAVE_clzv2di2;
  ena[551] = HAVE_clzv32qi2;
  ena[552] = HAVE_clzv16hi2;
  ena[553] = HAVE_clzv8si2;
  ena[554] = HAVE_clzv4di2;
  ena[555] = HAVE_ctzsi2;
  ena[556] = HAVE_ctzdi2;
  ena[557] = HAVE_popcountsi2;
  ena[558] = HAVE_popcountdi2;
  ena[559] = HAVE_popcountv16qi2;
  ena[560] = HAVE_popcountv8hi2;
  ena[561] = HAVE_popcountv4si2;
  ena[562] = HAVE_popcountv2di2;
  ena[563] = HAVE_popcountv32qi2;
  ena[564] = HAVE_popcountv16hi2;
  ena[565] = HAVE_popcountv8si2;
  ena[566] = HAVE_popcountv4di2;
  ena[567] = HAVE_sqrtsf2;
  ena[568] = HAVE_sqrtdf2;
  ena[569] = HAVE_sqrtv4sf2;
  ena[570] = HAVE_sqrtv2df2;
  ena[571] = HAVE_sqrtv8sf2;
  ena[572] = HAVE_sqrtv4df2;
  ena[573] = HAVE_movfcc;
  ena[574] = HAVE_movqi;
  ena[575] = HAVE_movhi;
  ena[576] = HAVE_movsi;
  ena[577] = HAVE_movdi;
  ena[578] = HAVE_movsf;
  ena[579] = HAVE_movdf;
  ena[580] = HAVE_movv16qi;
  ena[581] = HAVE_movv8hi;
  ena[582] = HAVE_movv4si;
  ena[583] = HAVE_movv2di;
  ena[584] = HAVE_movv32qi;
  ena[585] = HAVE_movv16hi;
  ena[586] = HAVE_movv8si;
  ena[587] = HAVE_movv4di;
  ena[588] = HAVE_movv4sf;
  ena[589] = HAVE_movv2df;
  ena[590] = HAVE_movv8sf;
  ena[591] = HAVE_movv4df;
  ena[592] = HAVE_movmisalignv16qi;
  ena[593] = HAVE_movmisalignv8hi;
  ena[594] = HAVE_movmisalignv4si;
  ena[595] = HAVE_movmisalignv2di;
  ena[596] = HAVE_movmisalignv32qi;
  ena[597] = HAVE_movmisalignv16hi;
  ena[598] = HAVE_movmisalignv8si;
  ena[599] = HAVE_movmisalignv4di;
  ena[600] = HAVE_movmisalignv4sf;
  ena[601] = HAVE_movmisalignv2df;
  ena[602] = HAVE_movmisalignv8sf;
  ena[603] = HAVE_movmisalignv4df;
  ena[604] = HAVE_insvsi;
  ena[605] = HAVE_insvdi;
  ena[606] = HAVE_extzvsi;
  ena[607] = HAVE_extzvdi;
  ena[608] = HAVE_cbranchqi4;
  ena[609] = HAVE_cbranchsi4;
  ena[610] = HAVE_cbranchdi4;
  ena[611] = HAVE_cbranchsf4;
  ena[612] = HAVE_cbranchdf4;
  ena[613] = HAVE_movsicc;
  ena[614] = HAVE_movdicc;
  ena[615] = HAVE_movsfcc;
  ena[616] = HAVE_movdfcc;
  ena[617] = HAVE_cstoresi4;
  ena[618] = HAVE_cstoredi4;
  ena[619] = HAVE_cstoresf4;
  ena[620] = HAVE_cstoredf4;
  ena[621] = HAVE_smulsi3_highpart;
  ena[622] = HAVE_smuldi3_highpart;
  ena[623] = HAVE_smulv16qi3_highpart;
  ena[624] = HAVE_smulv8hi3_highpart;
  ena[625] = HAVE_smulv4si3_highpart;
  ena[626] = HAVE_smulv2di3_highpart;
  ena[627] = HAVE_smulv32qi3_highpart;
  ena[628] = HAVE_smulv16hi3_highpart;
  ena[629] = HAVE_smulv8si3_highpart;
  ena[630] = HAVE_smulv4di3_highpart;
  ena[631] = HAVE_umulsi3_highpart;
  ena[632] = HAVE_umuldi3_highpart;
  ena[633] = HAVE_umulv16qi3_highpart;
  ena[634] = HAVE_umulv8hi3_highpart;
  ena[635] = HAVE_umulv4si3_highpart;
  ena[636] = HAVE_umulv2di3_highpart;
  ena[637] = HAVE_umulv32qi3_highpart;
  ena[638] = HAVE_umulv16hi3_highpart;
  ena[639] = HAVE_umulv8si3_highpart;
  ena[640] = HAVE_umulv4di3_highpart;
  ena[641] = HAVE_cpymemsi;
  ena[642] = HAVE_fmasf4;
  ena[643] = HAVE_fmadf4;
  ena[644] = HAVE_fmav4sf4;
  ena[645] = HAVE_fmav2df4;
  ena[646] = HAVE_fmav8sf4;
  ena[647] = HAVE_fmav4df4;
  ena[648] = HAVE_fmssf4;
  ena[649] = HAVE_fmsdf4;
  ena[650] = HAVE_fmsv4sf4;
  ena[651] = HAVE_fmsv2df4;
  ena[652] = HAVE_fmsv8sf4;
  ena[653] = HAVE_fmsv4df4;
  ena[654] = HAVE_fnmasf4;
  ena[655] = HAVE_fnmadf4;
  ena[656] = HAVE_fnmav4sf4;
  ena[657] = HAVE_fnmav2df4;
  ena[658] = HAVE_fnmav8sf4;
  ena[659] = HAVE_fnmav4df4;
  ena[660] = HAVE_fnmssf4;
  ena[661] = HAVE_fnmsdf4;
  ena[662] = HAVE_rintsf2;
  ena[663] = HAVE_rintdf2;
  ena[664] = HAVE_rintv4sf2;
  ena[665] = HAVE_rintv2df2;
  ena[666] = HAVE_rintv8sf2;
  ena[667] = HAVE_rintv4df2;
  ena[668] = HAVE_roundevensf2;
  ena[669] = HAVE_roundevendf2;
  ena[670] = HAVE_roundevenv4sf2;
  ena[671] = HAVE_roundevenv2df2;
  ena[672] = HAVE_roundevenv8sf2;
  ena[673] = HAVE_roundevenv4df2;
  ena[674] = HAVE_floorsf2;
  ena[675] = HAVE_floordf2;
  ena[676] = HAVE_floorv4sf2;
  ena[677] = HAVE_floorv2df2;
  ena[678] = HAVE_floorv8sf2;
  ena[679] = HAVE_floorv4df2;
  ena[680] = HAVE_ceilsf2;
  ena[681] = HAVE_ceildf2;
  ena[682] = HAVE_ceilv4sf2;
  ena[683] = HAVE_ceilv2df2;
  ena[684] = HAVE_ceilv8sf2;
  ena[685] = HAVE_ceilv4df2;
  ena[686] = HAVE_btruncsf2;
  ena[687] = HAVE_btruncdf2;
  ena[688] = HAVE_btruncv4sf2;
  ena[689] = HAVE_btruncv2df2;
  ena[690] = HAVE_btruncv8sf2;
  ena[691] = HAVE_btruncv4df2;
  ena[692] = HAVE_copysignsf3;
  ena[693] = HAVE_copysigndf3;
  ena[694] = HAVE_copysignv4sf3;
  ena[695] = HAVE_copysignv2df3;
  ena[696] = HAVE_copysignv8sf3;
  ena[697] = HAVE_copysignv4df3;
  ena[698] = HAVE_xorsignsf3;
  ena[699] = HAVE_xorsigndf3;
  ena[700] = HAVE_xorsignv4sf3;
  ena[701] = HAVE_xorsignv2df3;
  ena[702] = HAVE_xorsignv8sf3;
  ena[703] = HAVE_xorsignv4df3;
  ena[704] = HAVE_ldexpsf3;
  ena[705] = HAVE_ldexpdf3;
  ena[706] = HAVE_logbsf2;
  ena[707] = HAVE_logbdf2;
  ena[708] = HAVE_logbv4sf2;
  ena[709] = HAVE_logbv2df2;
  ena[710] = HAVE_logbv8sf2;
  ena[711] = HAVE_logbv4df2;
  ena[712] = HAVE_rsqrtsf2;
  ena[713] = HAVE_rsqrtdf2;
  ena[714] = HAVE_rsqrtv4sf2;
  ena[715] = HAVE_rsqrtv2df2;
  ena[716] = HAVE_rsqrtv8sf2;
  ena[717] = HAVE_rsqrtv4df2;
  ena[718] = HAVE_fmaxsf3;
  ena[719] = HAVE_fmaxdf3;
  ena[720] = HAVE_fmaxv4sf3;
  ena[721] = HAVE_fmaxv2df3;
  ena[722] = HAVE_fmaxv8sf3;
  ena[723] = HAVE_fmaxv4df3;
  ena[724] = HAVE_fminsf3;
  ena[725] = HAVE_fmindf3;
  ena[726] = HAVE_fminv4sf3;
  ena[727] = HAVE_fminv2df3;
  ena[728] = HAVE_fminv8sf3;
  ena[729] = HAVE_fminv4df3;
  ena[730] = HAVE_reduc_fmax_scal_v4sf;
  ena[731] = HAVE_reduc_fmax_scal_v2df;
  ena[732] = HAVE_reduc_fmax_scal_v8sf;
  ena[733] = HAVE_reduc_fmax_scal_v4df;
  ena[734] = HAVE_reduc_fmin_scal_v4sf;
  ena[735] = HAVE_reduc_fmin_scal_v2df;
  ena[736] = HAVE_reduc_fmin_scal_v8sf;
  ena[737] = HAVE_reduc_fmin_scal_v4df;
  ena[738] = HAVE_reduc_smax_scal_v16qi;
  ena[739] = HAVE_reduc_smax_scal_v8hi;
  ena[740] = HAVE_reduc_smax_scal_v4si;
  ena[741] = HAVE_reduc_smax_scal_v2di;
  ena[742] = HAVE_reduc_smax_scal_v32qi;
  ena[743] = HAVE_reduc_smax_scal_v16hi;
  ena[744] = HAVE_reduc_smax_scal_v8si;
  ena[745] = HAVE_reduc_smax_scal_v4di;
  ena[746] = HAVE_reduc_smax_scal_v4sf;
  ena[747] = HAVE_reduc_smax_scal_v2df;
  ena[748] = HAVE_reduc_smax_scal_v8sf;
  ena[749] = HAVE_reduc_smax_scal_v4df;
  ena[750] = HAVE_reduc_smin_scal_v16qi;
  ena[751] = HAVE_reduc_smin_scal_v8hi;
  ena[752] = HAVE_reduc_smin_scal_v4si;
  ena[753] = HAVE_reduc_smin_scal_v2di;
  ena[754] = HAVE_reduc_smin_scal_v32qi;
  ena[755] = HAVE_reduc_smin_scal_v16hi;
  ena[756] = HAVE_reduc_smin_scal_v8si;
  ena[757] = HAVE_reduc_smin_scal_v4di;
  ena[758] = HAVE_reduc_smin_scal_v4sf;
  ena[759] = HAVE_reduc_smin_scal_v2df;
  ena[760] = HAVE_reduc_smin_scal_v8sf;
  ena[761] = HAVE_reduc_smin_scal_v4df;
  ena[762] = HAVE_reduc_plus_scal_v4si;
  ena[763] = HAVE_reduc_plus_scal_v2di;
  ena[764] = HAVE_reduc_plus_scal_v8si;
  ena[765] = HAVE_reduc_plus_scal_v4di;
  ena[766] = HAVE_reduc_plus_scal_v4sf;
  ena[767] = HAVE_reduc_plus_scal_v2df;
  ena[768] = HAVE_reduc_plus_scal_v8sf;
  ena[769] = HAVE_reduc_plus_scal_v4df;
  ena[770] = HAVE_reduc_umax_scal_v16qi;
  ena[771] = HAVE_reduc_umax_scal_v8hi;
  ena[772] = HAVE_reduc_umax_scal_v4si;
  ena[773] = HAVE_reduc_umax_scal_v2di;
  ena[774] = HAVE_reduc_umax_scal_v32qi;
  ena[775] = HAVE_reduc_umax_scal_v16hi;
  ena[776] = HAVE_reduc_umax_scal_v8si;
  ena[777] = HAVE_reduc_umax_scal_v4di;
  ena[778] = HAVE_reduc_umin_scal_v16qi;
  ena[779] = HAVE_reduc_umin_scal_v8hi;
  ena[780] = HAVE_reduc_umin_scal_v4si;
  ena[781] = HAVE_reduc_umin_scal_v2di;
  ena[782] = HAVE_reduc_umin_scal_v32qi;
  ena[783] = HAVE_reduc_umin_scal_v16hi;
  ena[784] = HAVE_reduc_umin_scal_v8si;
  ena[785] = HAVE_reduc_umin_scal_v4di;
  ena[786] = HAVE_reduc_and_scal_v16qi;
  ena[787] = HAVE_reduc_and_scal_v8hi;
  ena[788] = HAVE_reduc_and_scal_v4si;
  ena[789] = HAVE_reduc_and_scal_v2di;
  ena[790] = HAVE_reduc_and_scal_v32qi;
  ena[791] = HAVE_reduc_and_scal_v16hi;
  ena[792] = HAVE_reduc_and_scal_v8si;
  ena[793] = HAVE_reduc_and_scal_v4di;
  ena[794] = HAVE_reduc_ior_scal_v16qi;
  ena[795] = HAVE_reduc_ior_scal_v8hi;
  ena[796] = HAVE_reduc_ior_scal_v4si;
  ena[797] = HAVE_reduc_ior_scal_v2di;
  ena[798] = HAVE_reduc_ior_scal_v32qi;
  ena[799] = HAVE_reduc_ior_scal_v16hi;
  ena[800] = HAVE_reduc_ior_scal_v8si;
  ena[801] = HAVE_reduc_ior_scal_v4di;
  ena[802] = HAVE_reduc_xor_scal_v16qi;
  ena[803] = HAVE_reduc_xor_scal_v8hi;
  ena[804] = HAVE_reduc_xor_scal_v4si;
  ena[805] = HAVE_reduc_xor_scal_v2di;
  ena[806] = HAVE_reduc_xor_scal_v32qi;
  ena[807] = HAVE_reduc_xor_scal_v16hi;
  ena[808] = HAVE_reduc_xor_scal_v8si;
  ena[809] = HAVE_reduc_xor_scal_v4di;
  ena[810] = HAVE_avgv16qi3_floor;
  ena[811] = HAVE_avgv8hi3_floor;
  ena[812] = HAVE_avgv4si3_floor;
  ena[813] = HAVE_avgv32qi3_floor;
  ena[814] = HAVE_avgv16hi3_floor;
  ena[815] = HAVE_avgv8si3_floor;
  ena[816] = HAVE_uavgv16qi3_floor;
  ena[817] = HAVE_uavgv8hi3_floor;
  ena[818] = HAVE_uavgv4si3_floor;
  ena[819] = HAVE_uavgv32qi3_floor;
  ena[820] = HAVE_uavgv16hi3_floor;
  ena[821] = HAVE_uavgv8si3_floor;
  ena[822] = HAVE_avgv16qi3_ceil;
  ena[823] = HAVE_avgv8hi3_ceil;
  ena[824] = HAVE_avgv4si3_ceil;
  ena[825] = HAVE_avgv32qi3_ceil;
  ena[826] = HAVE_avgv16hi3_ceil;
  ena[827] = HAVE_avgv8si3_ceil;
  ena[828] = HAVE_uavgv16qi3_ceil;
  ena[829] = HAVE_uavgv8hi3_ceil;
  ena[830] = HAVE_uavgv4si3_ceil;
  ena[831] = HAVE_uavgv32qi3_ceil;
  ena[832] = HAVE_uavgv16hi3_ceil;
  ena[833] = HAVE_uavgv8si3_ceil;
  ena[834] = HAVE_usadv16qi;
  ena[835] = HAVE_usadv32qi;
  ena[836] = HAVE_ssadv16qi;
  ena[837] = HAVE_ssadv32qi;
  ena[838] = HAVE_vec_pack_trunc_v8hi;
  ena[839] = HAVE_vec_pack_trunc_v4si;
  ena[840] = HAVE_vec_pack_trunc_v2di;
  ena[841] = HAVE_vec_pack_trunc_v16hi;
  ena[842] = HAVE_vec_pack_trunc_v8si;
  ena[843] = HAVE_vec_pack_trunc_v4di;
  ena[844] = HAVE_vec_pack_trunc_v2df;
  ena[845] = HAVE_vec_pack_trunc_v4df;
  ena[846] = HAVE_vec_permv16qi;
  ena[847] = HAVE_vec_permv8hi;
  ena[848] = HAVE_vec_permv4si;
  ena[849] = HAVE_vec_permv2di;
  ena[850] = HAVE_vec_permv32qi;
  ena[851] = HAVE_vec_permv16hi;
  ena[852] = HAVE_vec_permv8si;
  ena[853] = HAVE_vec_permv4di;
  ena[854] = HAVE_vec_permv4sf;
  ena[855] = HAVE_vec_permv2df;
  ena[856] = HAVE_vec_permv8sf;
  ena[857] = HAVE_vec_permv4df;
  ena[858] = HAVE_vec_setv16qi;
  ena[859] = HAVE_vec_setv8hi;
  ena[860] = HAVE_vec_setv4si;
  ena[861] = HAVE_vec_setv2di;
  ena[862] = HAVE_vec_setv8si;
  ena[863] = HAVE_vec_setv4di;
  ena[864] = HAVE_vec_setv4sf;
  ena[865] = HAVE_vec_setv2df;
  ena[866] = HAVE_vec_setv8sf;
  ena[867] = HAVE_vec_setv4df;
  ena[868] = HAVE_vec_unpacks_hi_v16qi;
  ena[869] = HAVE_vec_unpacks_hi_v8hi;
  ena[870] = HAVE_vec_unpacks_hi_v4si;
  ena[871] = HAVE_vec_unpacks_hi_v32qi;
  ena[872] = HAVE_vec_unpacks_hi_v16hi;
  ena[873] = HAVE_vec_unpacks_hi_v8si;
  ena[874] = HAVE_vec_unpacks_hi_v4sf;
  ena[875] = HAVE_vec_unpacks_hi_v8sf;
  ena[876] = HAVE_vec_unpacks_lo_v16qi;
  ena[877] = HAVE_vec_unpacks_lo_v8hi;
  ena[878] = HAVE_vec_unpacks_lo_v4si;
  ena[879] = HAVE_vec_unpacks_lo_v32qi;
  ena[880] = HAVE_vec_unpacks_lo_v16hi;
  ena[881] = HAVE_vec_unpacks_lo_v8si;
  ena[882] = HAVE_vec_unpacks_lo_v4sf;
  ena[883] = HAVE_vec_unpacks_lo_v8sf;
  ena[884] = HAVE_vec_unpacku_hi_v16qi;
  ena[885] = HAVE_vec_unpacku_hi_v8hi;
  ena[886] = HAVE_vec_unpacku_hi_v4si;
  ena[887] = HAVE_vec_unpacku_hi_v32qi;
  ena[888] = HAVE_vec_unpacku_hi_v16hi;
  ena[889] = HAVE_vec_unpacku_hi_v8si;
  ena[890] = HAVE_vec_unpacku_lo_v16qi;
  ena[891] = HAVE_vec_unpacku_lo_v8hi;
  ena[892] = HAVE_vec_unpacku_lo_v4si;
  ena[893] = HAVE_vec_unpacku_lo_v32qi;
  ena[894] = HAVE_vec_unpacku_lo_v16hi;
  ena[895] = HAVE_vec_unpacku_lo_v8si;
  ena[896] = HAVE_vec_widen_smult_hi_v32qi;
  ena[897] = HAVE_vec_widen_smult_hi_v16hi;
  ena[898] = HAVE_vec_widen_smult_lo_v32qi;
  ena[899] = HAVE_vec_widen_smult_lo_v16hi;
  ena[900] = HAVE_vec_widen_ssub_hi_v32qi;
  ena[901] = HAVE_vec_widen_ssub_hi_v16hi;
  ena[902] = HAVE_vec_widen_ssub_lo_v32qi;
  ena[903] = HAVE_vec_widen_ssub_lo_v16hi;
  ena[904] = HAVE_vec_widen_sadd_hi_v32qi;
  ena[905] = HAVE_vec_widen_sadd_hi_v16hi;
  ena[906] = HAVE_vec_widen_sadd_lo_v32qi;
  ena[907] = HAVE_vec_widen_sadd_lo_v16hi;
  ena[908] = HAVE_vec_widen_umult_hi_v32qi;
  ena[909] = HAVE_vec_widen_umult_hi_v16hi;
  ena[910] = HAVE_vec_widen_umult_lo_v32qi;
  ena[911] = HAVE_vec_widen_umult_lo_v16hi;
  ena[912] = HAVE_vec_widen_usub_hi_v32qi;
  ena[913] = HAVE_vec_widen_usub_hi_v16hi;
  ena[914] = HAVE_vec_widen_usub_lo_v32qi;
  ena[915] = HAVE_vec_widen_usub_lo_v16hi;
  ena[916] = HAVE_vec_widen_uadd_hi_v32qi;
  ena[917] = HAVE_vec_widen_uadd_hi_v16hi;
  ena[918] = HAVE_vec_widen_uadd_lo_v32qi;
  ena[919] = HAVE_vec_widen_uadd_lo_v16hi;
  ena[920] = HAVE_atomic_addqi;
  ena[921] = HAVE_atomic_addhi;
  ena[922] = HAVE_atomic_addsi;
  ena[923] = HAVE_atomic_adddi;
  ena[924] = HAVE_atomic_andsi;
  ena[925] = HAVE_atomic_anddi;
  ena[926] = HAVE_atomic_compare_and_swapqi;
  ena[927] = HAVE_atomic_compare_and_swaphi;
  ena[928] = HAVE_atomic_compare_and_swapsi;
  ena[929] = HAVE_atomic_compare_and_swapdi;
  ena[930] = HAVE_atomic_exchangeqi;
  ena[931] = HAVE_atomic_exchangehi;
  ena[932] = HAVE_atomic_exchangesi;
  ena[933] = HAVE_atomic_exchangedi;
  ena[934] = HAVE_atomic_fetch_addqi;
  ena[935] = HAVE_atomic_fetch_addhi;
  ena[936] = HAVE_atomic_fetch_addsi;
  ena[937] = HAVE_atomic_fetch_adddi;
  ena[938] = HAVE_atomic_fetch_andqi;
  ena[939] = HAVE_atomic_fetch_andhi;
  ena[940] = HAVE_atomic_fetch_andsi;
  ena[941] = HAVE_atomic_fetch_anddi;
  ena[942] = HAVE_atomic_fetch_nandqi;
  ena[943] = HAVE_atomic_fetch_nandhi;
  ena[944] = HAVE_atomic_fetch_orqi;
  ena[945] = HAVE_atomic_fetch_orhi;
  ena[946] = HAVE_atomic_fetch_orsi;
  ena[947] = HAVE_atomic_fetch_ordi;
  ena[948] = HAVE_atomic_fetch_subqi;
  ena[949] = HAVE_atomic_fetch_subhi;
  ena[950] = HAVE_atomic_fetch_xorqi;
  ena[951] = HAVE_atomic_fetch_xorhi;
  ena[952] = HAVE_atomic_fetch_xorsi;
  ena[953] = HAVE_atomic_fetch_xordi;
  ena[954] = HAVE_atomic_loadqi;
  ena[955] = HAVE_atomic_loadhi;
  ena[956] = HAVE_atomic_loadsi;
  ena[957] = HAVE_atomic_loaddi;
  ena[958] = HAVE_atomic_orsi;
  ena[959] = HAVE_atomic_ordi;
  ena[960] = HAVE_atomic_storeqi;
  ena[961] = HAVE_atomic_storehi;
  ena[962] = HAVE_atomic_storesi;
  ena[963] = HAVE_atomic_storedi;
  ena[964] = HAVE_atomic_xorsi;
  ena[965] = HAVE_atomic_xordi;
  ena[966] = HAVE_get_thread_pointersi;
  ena[967] = HAVE_get_thread_pointerdi;
}

/* Returns TRUE if the target supports any of the partial vector
   optabs: while_ult_optab, len_load_optab, len_store_optab,
   mask_len_load_optab or mask_len_store_optab,
   for any mode.  */
bool
partial_vectors_supported_p (void)
{
	return false;
}
static int
lookup_handler (unsigned scode)
{
  int l = 0, h = ARRAY_SIZE (pats), m;
  while (h > l)
    {
      m = (h + l) / 2;
      if (scode == pats[m].scode)
        return m;
      else if (scode < pats[m].scode)
        h = m;
      else
        l = m + 1;
    }
  return -1;
}

enum insn_code
raw_optab_handler (unsigned scode)
{
  int i = lookup_handler (scode);
  return (i >= 0 && this_fn_optabs->pat_enable[i]
          ? pats[i].icode : CODE_FOR_nothing);
}

bool
swap_optab_enable (optab op, machine_mode m, bool set)
{
  unsigned scode = (op << 20) | m;
  int i = lookup_handler (scode);
  if (i >= 0)
    {
      bool ret = this_fn_optabs->pat_enable[i];
      this_fn_optabs->pat_enable[i] = set;
      return ret;
    }
  else
    {
      gcc_assert (!set);
      return false;
    }
}

const struct convert_optab_libcall_d convlib_def[NUM_CONVLIB_OPTABS] = {
  { "extend", gen_extend_conv_libfunc },
  { "trunc", gen_trunc_conv_libfunc },
  { NULL, NULL },
  { "fix", gen_fp_to_int_conv_libfunc },
  { "fixuns", gen_fp_to_int_conv_libfunc },
  { "float", gen_int_to_fp_conv_libfunc },
  { NULL, gen_ufloat_conv_libfunc },
  { "lrint", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lround", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lfloor", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lceil", gen_int_to_fp_nondecimal_conv_libfunc },
  { "fract", gen_fract_conv_libfunc },
  { "fractuns", gen_fractuns_conv_libfunc },
  { "satfract", gen_satfract_conv_libfunc },
  { "satfractuns", gen_satfractuns_conv_libfunc },
};

const struct optab_libcall_d normlib_def[NUM_NORMLIB_OPTABS] = {
  { '3', "add", gen_int_fp_fixed_libfunc },
  { '3', "add", gen_intv_fp_libfunc },
  { '3', "ssadd", gen_signed_fixed_libfunc },
  { '3', "usadd", gen_unsigned_fixed_libfunc },
  { '3', "sub", gen_int_fp_fixed_libfunc },
  { '3', "sub", gen_intv_fp_libfunc },
  { '3', "sssub", gen_signed_fixed_libfunc },
  { '3', "ussub", gen_unsigned_fixed_libfunc },
  { '3', "mul", gen_int_fp_fixed_libfunc },
  { '3', "mul", gen_intv_fp_libfunc },
  { '3', "ssmul", gen_signed_fixed_libfunc },
  { '3', "usmul", gen_unsigned_fixed_libfunc },
  { '3', "div", gen_int_fp_signed_fixed_libfunc },
  { '3', "divv", gen_int_libfunc },
  { '3', "ssdiv", gen_signed_fixed_libfunc },
  { '3', "udiv", gen_int_unsigned_fixed_libfunc },
  { '3', "usdiv", gen_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '3', "mod", gen_int_libfunc },
  { '3', "umod", gen_int_libfunc },
  { '2', "ftrunc", gen_fp_libfunc },
  { '3', "and", gen_int_libfunc },
  { '3', "ior", gen_int_libfunc },
  { '3', "xor", gen_int_libfunc },
  { '3', "ashl", gen_int_fixed_libfunc },
  { '3', "ssashl", gen_signed_fixed_libfunc },
  { '3', "usashl", gen_unsigned_fixed_libfunc },
  { '3', "ashr", gen_int_signed_fixed_libfunc },
  { '3', "lshr", gen_int_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '3', "min", gen_int_fp_libfunc },
  { '3', "max", gen_int_fp_libfunc },
  { '3', "umin", gen_int_libfunc },
  { '3', "umax", gen_int_libfunc },
  { '2', "neg", gen_int_fp_fixed_libfunc },
  { '2', "neg", gen_intv_fp_libfunc },
  { '2', "ssneg", gen_signed_fixed_libfunc },
  { '2', "usneg", gen_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '2', "one_cmpl", gen_int_libfunc },
  { '\0', NULL, NULL },
  { '2', "ffs", gen_int_libfunc },
  { '2', "clz", gen_int_libfunc },
  { '2', "ctz", gen_int_libfunc },
  { '2', "clrsb", gen_int_libfunc },
  { '2', "popcount", gen_int_libfunc },
  { '2', "parity", gen_int_libfunc },
  { '2', "cmp", gen_int_fp_fixed_libfunc },
  { '2', "ucmp", gen_int_libfunc },
  { '2', "eq", gen_fp_libfunc },
  { '2', "ne", gen_fp_libfunc },
  { '2', "gt", gen_fp_libfunc },
  { '2', "ge", gen_fp_libfunc },
  { '2', "lt", gen_fp_libfunc },
  { '2', "le", gen_fp_libfunc },
  { '2', "unord", gen_fp_libfunc },
  { '2', "powi", gen_fp_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
};

enum rtx_code const optab_to_code_[NUM_OPTABS] = {
  UNKNOWN,
  SIGN_EXTEND,
  TRUNCATE,
  ZERO_EXTEND,
  FIX,
  UNSIGNED_FIX,
  FLOAT,
  UNSIGNED_FLOAT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  FRACT_CONVERT,
  UNSIGNED_FRACT_CONVERT,
  SAT_FRACT,
  UNSIGNED_SAT_FRACT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  PLUS,
  PLUS,
  SS_PLUS,
  US_PLUS,
  MINUS,
  MINUS,
  SS_MINUS,
  US_MINUS,
  MULT,
  MULT,
  SS_MULT,
  US_MULT,
  DIV,
  DIV,
  SS_DIV,
  UDIV,
  US_DIV,
  UNKNOWN,
  UNKNOWN,
  MOD,
  UMOD,
  UNKNOWN,
  AND,
  IOR,
  XOR,
  ASHIFT,
  SS_ASHIFT,
  US_ASHIFT,
  ASHIFTRT,
  LSHIFTRT,
  ROTATE,
  ROTATERT,
  ASHIFT,
  ASHIFTRT,
  LSHIFTRT,
  ROTATE,
  ROTATERT,
  SMIN,
  SMAX,
  UMIN,
  UMAX,
  NEG,
  NEG,
  SS_NEG,
  US_NEG,
  ABS,
  ABS,
  NOT,
  BSWAP,
  FFS,
  CLZ,
  CTZ,
  CLRSB,
  POPCOUNT,
  PARITY,
  UNKNOWN,
  UNKNOWN,
  EQ,
  NE,
  GT,
  GE,
  LT,
  LE,
  UNORDERED,
  UNKNOWN,
  SQRT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  SET,
  STRICT_LOW_PART,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  COMPARE,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  FMA,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  VEC_DUPLICATE,
  VEC_SERIES,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
};

const optab code_to_optab_[NUM_RTX_CODE] = {
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  mov_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  movstrict_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  cbranch_optab,
  add_optab,
  sub_optab,
  neg_optab,
  smul_optab,
  ssmul_optab,
  usmul_optab,
  unknown_optab,
  unknown_optab,
  sdiv_optab,
  ssdiv_optab,
  usdiv_optab,
  smod_optab,
  udiv_optab,
  umod_optab,
  and_optab,
  ior_optab,
  xor_optab,
  one_cmpl_optab,
  ashl_optab,
  rotl_optab,
  ashr_optab,
  lshr_optab,
  rotr_optab,
  smin_optab,
  smax_optab,
  umin_optab,
  umax_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  ne_optab,
  eq_optab,
  ge_optab,
  gt_optab,
  le_optab,
  lt_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unord_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  abs_optab,
  sqrt_optab,
  bswap_optab,
  ffs_optab,
  clrsb_optab,
  clz_optab,
  ctz_optab,
  popcount_optab,
  parity_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  vec_duplicate_optab,
  vec_series_optab,
  ssadd_optab,
  usadd_optab,
  sssub_optab,
  ssneg_optab,
  usneg_optab,
  unknown_optab,
  ssashl_optab,
  usashl_optab,
  ussub_optab,
  unknown_optab,
  unknown_optab,
  fma_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
};

